-- Addon Support

addHook("ThinkFrame", function(player)
	for player in players.iterate
		if player.realmo.skin == "ace" or player.realmo.skin == "draco"
			-- Characters
			
			---- Crispy Chars
			
			/*if CC_NeckSkins
				CC_NeckSkins["ace"]
			end*/
			
			if CC_TrickSkins
				CC_TrickSkins["ace"] =
				{{sprite2 = SPR2_SPNG,
				rotation = "random",
				tics = 0},
				{sprite2 = SPR2_EDGE,
				rarity = 2*FRACUNIT,
				rotation = "random",
				tics = 0,
				frames = 1},
				{sprite2 = SPR2_SWIM,
				rotation = "random",
				tics = 0,
				frames = 1}}
			end
			
			/*if CC_DanceSkins
				CC_DanceSkins["ace"]
			end*/
			
			---- Kirby
			
			if kirbyabilitytable and K_AddAbility
				kirbyabilitytable["ace"] = K_AddAbility(K_ELEMENTAL, false, "ELEMENTAL")
				kirbyabilitytable[MT_ACEEARTH] = 3
				kirbyabilitytable[MT_ACEBOULDER] = 3
				kirbyabilitytable[MT_ACEWATER] = 2
				kirbyabilitytable[MT_ACEAIR] = 7
				kirbyabilitytable[MT_ACEFIRE] = 1
				kirbyabilitytable["draco"] = 1
				kirbyabilitytable[MT_ADFIREBALL] = 1
			end
			
			---- Rush Chars
			
			/*if boatchars
				if player.wiz.element == 0
					boatchars["ace"] = {0, 1, 1}
				elseif player.wiz.element == 1
					boatchars["ace"] = {0, 0, 0}
				elseif player.wiz.element == 2
					boatchars["ace"] = {0, 1, 0}
				elseif player.wiz.element == 3
					boatchars["ace"] = {0, 1, 0}
				end
			end*/
			
			---- Shadow
			
			if AddBikeTvInteraction
				AddBikeTvInteraction("ace", function(mo)
					mo.player.dragonfromshadow = true
				end)
			end
			
			-- Maps
			
			---- SADX
			
			------ Ace's story?
		end
	end
end)

local camera = nil
local firstperson = false
local fpaim = 0

hud.add(function(v, player, realcamera)
	camera = realcamera
	
	if realcamera.chase
		firstperson = false
	else
		firstperson = true
	end
	
	if firstperson
		fpaim = 1
	else
		fpaim = 0
	end
end, "game")

-- Kirby

rawset(_G, "K_ELEMENTAL", function(checkflags, destroy, late, player)
	if(checkflags)
		if(player.kvars.ablstate)
			return AF_NOFLOAT|AF_NODUCK|AF_NODROP
		else
			return 0
		end
	end
	
	if(destroy)
		player.height = 24*FRACUNIT
		player.mo.radius = 16*FRACUNIT
		
		player.wiz = nil
		
		return
	end
	
	if(late)
		return
	end
	
	if player.wiz
		local RT = BT_USE|BT_SPIN
		
		-- Magic --
		
		-- Switch Element
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not (gametyperules & GTR_RINGSLINGER)
			if player.lbtap
				player.wiz.element = $-1
				S_StartSound(nil, sfx_tink)
			elseif player.rbtap
				player.wiz.element = $+1
				S_StartSound(nil, sfx_tink)
			end
		end
		
		if player.wiz.element < 0
			player.wiz.element = 3
		elseif player.wiz.element > 3
			player.wiz.element = 0
		end
		
		-- Cast
		
		player.wiz.castangle = player.drawangle
		
		if (player.cmd.buttons & RT) and player.playerstate == PST_LIVE
		and not P_PlayerInPain(player) and not (gametyperules & GTR_RINGSLINGER)
		and not player.wiz.castrecharge and not player.wiz.shield
		and not player.kvars.ducking and not player.kvars.floating
			player.kvars.ablstate = 1
			
			if player.wiz.casttime > 0
				player.wiz.casting = true
				player.wiz.casttime = $-1
				player.wiz.castdelay = max($-1, 0)
				
				if player.wiz.element == 0 and player.wiz.castdelay == 0
					local Rock = P_SPMAngle(player.mo, MT_ACEEARTH, player.wiz.castangle, fpaim)
					
					if Rock and Rock.valid
						P_MoveOrigin(Rock, Rock.x, Rock.y, Rock.z + Rock.height/4)
						
						Rock.scale = 1*FRACUNIT/4
						Rock.scalespeed = 1*FRACUNIT/4
						Rock.destscale = 1*FRACUNIT
						Rock.tracer = player.mo
					end
					
					player.wiz.castdelay = 5
				elseif player.wiz.element == 1
					local Water = P_SPMAngle(player.mo, MT_ACEWATER, player.wiz.castangle, fpaim)
					
					if Water and Water.valid
						P_MoveOrigin(Water, Water.x, Water.y, Water.z + Water.height/4)
						
						Water.scale = 1*FRACUNIT/2
						Water.scalespeed = 1*FRACUNIT/8
						Water.destscale = 1*FRACUNIT
						Water.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_splish)
					end
				elseif player.wiz.element == 2
					local Wind = P_SPMAngle(player.mo, MT_ACEAIR, player.wiz.castangle, fpaim)
					
					if Wind and Wind.valid
						P_MoveOrigin(Wind, Wind.x, Wind.y, Wind.z + Wind.height/4)
						
						Wind.scale = 1*FRACUNIT/2
						Wind.scalespeed = 1*FRACUNIT/8
						Wind.destscale = 1*FRACUNIT
						Wind.tracer = player.mo
						
						if not S_SoundPlaying(player.mo, sfx_s3kces)
							S_StartSound(player.mo, sfx_s3kces)
						end
					end
				elseif player.wiz.element == 3
					local Flame = P_SPMAngle(player.mo, MT_ACEFIRE, player.wiz.castangle, fpaim)
					
					if Flame and Flame.valid
						P_MoveOrigin(Flame, Flame.x, Flame.y, Flame.z + Flame.height/4)
						
						Flame.scale = 1*FRACUNIT/2
						Flame.scalespeed = 1*FRACUNIT/8
						Flame.destscale = 1*FRACUNIT
						Flame.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_fire)
					end
				end
			else
				player.wiz.castrecharge = true
			end
			
			//CASTSPRITES
			
		else
			player.kvars.ablstate = 0
			
			player.wiz.casting = false
			player.wiz.castdelay = 0
		end
		
		if player.xtap and player.wiz.castrecharge
			player.wiz.castrecharge = false
		end
		
		if not player.wiz.casting
			player.wiz.casttime = min($+1, 100)
		end
	else
		player.wiz =
		{element = 0,
		casting = false,
		castaim = 0,
		casttime = 100,
		castangle = 0,
		castrecharge = false,
		castdelay = 0,
		shield = false,
		shieldtime = 100,
		shieldrecharge = false,
		shielddelay = 0,
		parry = false,
		parrytime = 2,
		allowed = true}
	end
end)