-- Dragon Init

freeslot("MT_ACEDRAGON", "MT_ADFIREBALL",
"MT_ACEDRAGON_SPAWNER", "MT_ACEDRAGON_CHAOSEMERALD")

mobjinfo[MT_ACEDRAGON] = {
	doomednum = -1,
	spawnstate = S_PLAY_STND,
	seesound = sfx_s1b3,
	painstate = S_PLAY_PAIN,
	painsound = sfx_altdi1,
	missilestate = S_PLAY_FIRE,
	deathstate = S_PLAY_DEAD,
	xdeathstate = S_PLAY_DRWN,
	raisestate = MT_ADFIREBALL,
	deathsound = sfx_altdi1,
	spawnhealth = 3,
	radius = 48*FRACUNIT,
	height = 60*FRACUNIT,
	flags = MF_SHOOTABLE
}

mobjinfo[MT_ADFIREBALL] =
{
	doomednum = -1,
	spawnstate = S_SMALLFIREBAR1,
	spawnhealth = 1,
	reactiontime = 8,
	seesound = sfx_s1b3,
	deathsound = sfx_s1b3,
	speed = 24*FRACUNIT,
	radius = 17*FRACUNIT,
	height = 34*FRACUNIT,
	displayoffset = 1,
	mass = DMG_FIRE,
	damage = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY|MF_FLOAT|MF_FIRE
}

mobjinfo[MT_ACEDRAGON_SPAWNER] =
{
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	deathsound = sfx_ncspec,
	spawnhealth = 1,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_ACEDRAGON_CHAOSEMERALD] =
{
	doomednum = -1,
	spawnstate = S_CEMG1,
	deathsound = sfx_ncspec,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

-- Dragon Setup

local A = BT_JUMP
local B = BT_CUSTOM2
local X = BT_USE|BT_SPIN if srb2p X = BT_CUSTOM3 end
local Y = BT_CUSTOM3 if srb2p Y = 0 end
local BACK = BT_TOSSFLAG

local spawning = false
local spawntime = 100

local ontime = 10
local offtime = 10
local stopflytime = 10

local duration = 0

local posadjust = false

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.realmo and player.realmo.skin == "ace" and player.wiz and not srb2p and not pso
			if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and not player.wiz.ondragon and not player.powers[pw_super]
			and not player.mysticsuper and not player.dragonfromshadow
				local dist = 0
				local inrange = false
				
				if player.wiz.dragon and player.wiz.dragon.valid
					dist = P_AproxDistance(P_AproxDistance(player.mo.x - player.wiz.dragon.x, player.mo.y - player.wiz.dragon.y), player.mo.z - player.wiz.dragon.z)
					
					if (dist >= 0 and dist < 256*player.mo.scale)
						inrange = true
					else
						inrange = false
					end
					
					if player.ytap and (dist >= 0 and dist < 64*player.mo.scale)
					or (player.cmd.buttons & Y) and ontime <= 9 and not player.mo.issucked
						if ontime
							ontime = max($-1, 0)
						else
							P_MoveOrigin(player.mo, player.wiz.dragon.x, player.wiz.dragon.y, player.wiz.dragon.z)
							
							player.normalspeed = 30*FRACUNIT
							player.runspeed = 36*FRACUNIT
							player.jumpfactor = 227*FRACUNIT/200
							player.height = 60*FRACUNIT+24*FRACUNIT
							player.shieldscale = 2*FRACUNIT
							player.camerascale = 5*FRACUNIT/4
							
							ontime = 10
							
							player.flying = false
							player.gliding = false
							player.crouching = false
							player.forcecrouch = false
							player.dashtime = 0
							player.dashdelay = 0
							
							player.wiz.ondragon = true
						end
					else
						ontime = 10
					end
				end
				
				if not player.wiz.dragon or not inrange
					if (player.cmd.buttons & Y) and All7Emeralds(emeralds)
					and (spawning or not duration) and not player.mo.issucked
						if spawntime
							if spawntime == 90
								local spawner = P_SpawnMobj(
								player.mo.x + player.rmomx + FixedMul(cos(player.drawangle), player.mo.radius + mobjinfo[MT_ACEDRAGON].radius + 100*FRACUNIT),
								player.mo.y + player.rmomy + FixedMul(sin(player.drawangle), player.mo.radius + mobjinfo[MT_ACEDRAGON].radius + 100*FRACUNIT),
								player.mo.z + player.mo.momz, MT_ACEDRAGON_SPAWNER)
								
								spawner.tracer = player.mo
								
								for i = 1, 7
									local emerald = P_SpawnMobj(spawner.x, spawner.y, spawner.z, MT_ACEDRAGON_CHAOSEMERALD)
									
									emerald.tracer = spawner
									emerald.state = S_CEMG1+(i-1)
									emerald.angle = FixedAngle((360*FRACUNIT)/7)
									emerald.scale = 0
									emerald.destscale = emerald.tracer.scale
									emerald.number = i
								end
							end
							
							spawning = true
							spawntime = max($-1, 0)
						end
					else
						spawning = false
						spawntime = min($+1, 100)
					end
					
					if spawntime <= 90
						player.wiz.banstate = true
					end
				end
			elseif player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and (player.powers[pw_super] or player.mysticsuper or player.dragonfromshadow)
			and not player.wiz.ondragon
				if player.wiz.dragon and player.wiz.dragon.valid
					P_MoveOrigin(player.wiz.dragon, player.mo.x, player.mo.y, player.mo.z)
					
					player.normalspeed = 30*FRACUNIT
					player.runspeed = 36*FRACUNIT
					player.jumpfactor = 227*FRACUNIT/200
					player.height = 60*FRACUNIT+24*FRACUNIT
					player.shieldscale = 2*FRACUNIT
					player.camerascale = 5*FRACUNIT/4
					
					player.flying = true
					player.gliding = false
					player.crouching = false
					player.forcecrouch = false
					player.dashtime = 0
					player.dashdelay = 0
					
					player.wiz.ondragon = true
					
					if player.dragonfromshadow
						player.dragonfromshadow = false
					end
				else
					local spawner = P_SpawnMobj(
					player.mo.x + player.rmomx,
					player.mo.y + player.rmomy,
					player.mo.z + player.mo.momz, MT_ACEDRAGON_SPAWNER)
					
					spawner.tracer = player.mo
					
					spawning = true
					spawntime = 0
				end
			end
		end
	end
end)

-- Dragon Thinker

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.target and mobj.target.valid and mobj.target.player.wiz
			mobj.skin = "draco"
			
			if not G_GametypeHasTeams()
				mobj.color = R_GetColorByName(mobj.target.player.skincolor-46)
			else
				mobj.color = R_GetColorByName(mobj.target.player.skincolor)
			end
			
			if mobj.target.player.wiz.ondragon
				mobj.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
				
				P_MoveOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z)
				
				mobj.state = mobj.target.state
				mobj.frame = mobj.target.frame
				mobj.angle = mobj.target.player.drawangle
			else
				mobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT&~MF_NOGRAVITY
				
				if P_IsObjectOnGround(mobj)
					mobj.state = S_PLAY_STND
				else
					mobj.state = S_PLAY_FALL
				end
			end
			
			if P_MobjFlip(mobj.target) > 0
				mobj.flags2 = $&~MF2_OBJECTFLIP
				mobj.eflags = $&~MFE_VERTICALFLIP
			else
				mobj.flags2 = $|MF2_OBJECTFLIP
				mobj.eflags = $|MFE_VERTICALFLIP
			end
			
			mobj.scale = mobj.target.scale
			
			if ARTH_Ace.AceHealth
				mobj.health = mobj.target.player.wiz.fairy.health
			else
				mobj.health = mobj.target.health
			end
		else
			P_RemoveMobj(mobj)
		end
	end
end, MT_ACEDRAGON)

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target and target.valid
		return false
	end
end, MT_ACEDRAGON)

-- Activate Flying and Gliding

---- While Falling

addHook("JumpSpecial", function(player)
	if player.gotflag return end
	if (player.mo.eflags & MFE_UNDERWATER) return end
	
	if player.mo.valid and (player.mo.skin == "draco"
	or (player.mo.skin == "ace" and player.wiz and player.wiz.ondragon
	and player.wiz.dragon and player.wiz.dragon.valid))
	and (not player.flying or player.dashtime)
	and not (player.pflags & PF_JUMPED) and player.atap
	and not (player.pflags & PF_THOKKED)
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			player.flying = true
		elseif ((gametyperules & GTR_RINGSLINGER) or srb2p)
			player.gliding = false
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			Thok.color = SKINCOLOR_CLOUDY
			player.pflags = $|PF_THOKKED
		end
		S_StartSound(player.mo, sfx_mswing)
	end
end)

---- While Jumping

addHook("AbilitySpecial", function(player)
	if player.gotflag return end
	if (player.mo.eflags & MFE_UNDERWATER) return end
	
	if player.mo.valid and (player.mo.skin == "draco"
	or (player.mo.skin == "ace" and player.wiz and player.wiz.ondragon
	and player.wiz.dragon and player.wiz.dragon.valid))
	and (not player.flying or player.dashtime)
	and not (player.pflags & PF_THOKKED)
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			player.flying = true
		elseif ((gametyperules & GTR_RINGSLINGER) or srb2p)
			player.gliding = false
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			Thok.color = SKINCOLOR_CLOUDY
			player.pflags = $|PF_THOKKED
		end
		S_StartSound(player.mo, sfx_mswing)
	end
end)

-- Fire Sprites

local FIRESPRITES = {
	[SPR2_STND] = SPR2_FIRE,
	[SPR2_WAIT] = SPR2_FIRE,
	[SPR2_EDGE] = SPR2_FIRE,
	
	[SPR2_WALK] = SPR2_FWLK,
	[SPR2_RUN_] = SPR2_FRUN,
	[SPR2_SKID] = SPR2_FSKD,
	
	[SPR2_JUMP] = SPR2_FAIR,
	[SPR2_SPNG] = SPR2_FAIR,
	[SPR2_FALL] = SPR2_FAIR,
	
	[SPR2_SWIM] = SPR2_FSWM
}

local camera = nil
local firstperson = false
local fpaim = 0
hud.add(function(v, player, realcamera)
	camera = realcamera
	
	if realcamera.chase
		firstperson = false
	else
		firstperson = true
	end
	
	if firstperson
		fpaim = 1
	else
		fpaim = 0
	end
end, "game")

-- Player Think

addHook("PlayerThink", function(player)
	if player.mo and (player.mo.skin == "draco" or (player.mo.skin == "ace"
	and player.wiz and player.wiz.ondragon
	and player.wiz.dragon and player.wiz.dragon.valid))
	and player.powers[pw_carry] != CR_NIGHTSMODE
		if player.mo.skin == "ace"
			player.mo.spriteyoffset = player.mo.height/2
			
			if player.ytap or (player.cmd.buttons & Y) and offtime <= 9
			and not player.powers[pw_super] and not player.mysticsuper
			and not player.hyper or player.mo.issucked
				if offtime and not player.mo.issucked
					offtime = max($-1, 0)
				else
					player.wiz.dragon.momx = player.rmomx
					player.wiz.dragon.momy = player.rmomy
					player.wiz.dragon.momz = player.mo.momz
					
					player.normalspeed = 15*FRACUNIT
					player.runspeed = 20*FRACUNIT
					player.jumpfactor = 1*FRACUNIT
					player.height = 48*FRACUNIT
					player.shieldscale = 29*FRACUNIT/20
					player.camerascale = 1*FRACUNIT
					
					player.mo.spriteyoffset = 0
					
					P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + player.mo.height/2)
					
					player.mo.state = S_PLAY_FALL
					
					offtime = 10
					
					player.flying = false
					player.gliding = false
					player.crouching = false
					player.forcecrouch = false
					player.dashtime = 0
					player.dashdelay = 0
					
					player.wiz.ondragon = false
				end
			else
				offtime = 10
			end
		end
		
		local TwoD = twodlevel or (player.mo.flags2 & MF2_TWOD)
		
		-- Fly and Glide
		
		if (player.cmd.buttons & A) and player.mo.momz < 0
		and not player.flying and not player.gliding
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and player.mo.state != S_PLAY_ROLL and not P_IsObjectOnGround(player.mo)
			player.gliding = true
		end
		
		if (player.flying or player.gliding and (player.cmd.buttons & A))
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and player.mo.state != S_PLAY_ROLL and not P_IsObjectOnGround(player.mo)
			if abs(player.mo.momx) >= 16*FRACUNIT or abs(player.mo.momy) >= 16*FRACUNIT
				if not posadjust
					posadjust = true
					P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + player.mo.height/4)
				end
				
				if player.mo.skin == "ace"
					player.height = 30*FRACUNIT+12*FRACUNIT
				else
					player.height = 30*FRACUNIT
				end
			else
				if posadjust
					posadjust = false
					P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z - player.mo.height/4)
				end
				
				if player.mo.skin == "ace"
					player.height = 60*FRACUNIT+24*FRACUNIT
				else
					player.height = 60*FRACUNIT
				end
			end
			
			if player.flying
				if player.gliding
					player.gliding = false
				end
				
				if (player.cmd.buttons & A)
					if player.mo.momz < 0
						player.mo.momz = 1*FRACUNIT
					else
						player.mo.momz = min($+1*FRACUNIT, 18*FRACUNIT)
					end
				elseif (player.cmd.buttons & B)
					if player.mo.momz > 0
						player.mo.momz = -1*FRACUNIT
					else
						player.mo.momz = max($-1*FRACUNIT, -18*FRACUNIT)
					end
				else
					if player.mo.momz < 0
						player.mo.momz = min($+1*FRACUNIT, 0)
					else
						player.mo.momz = max($-1*FRACUNIT, 0)
					end
				end
				
				if player.backtap or (player.cmd.buttons & BACK) and stopflytime <= 9
					if stopflytime
						stopflytime = max($-1, 0)
					else
						player.flying = false
					end
				else
					stopflytime = 10
				end
			elseif player.gliding
				if (player.cmd.buttons & B)
					player.mo.momz = max($-1*FRACUNIT, -18*FRACUNIT)
				else
					if player.mo.momz > -1*FRACUNIT
						player.mo.momz = max($-1*FRACUNIT, -2*FRACUNIT)
					else
						player.mo.momz = min($+1*FRACUNIT, -2*FRACUNIT)
					end
				end
			end
		else
			player.flying = false
			player.gliding = false
		end
		
		-- Crouch
		
		if (((player.btap and not player.crouching) or ((player.cmd.buttons & B) and player.crouching)
		or (TwoD and player.cmd.forwardmove < -20 and not player.mo.currentaxis)) and player.playerstate == PST_LIVE
		and not P_PlayerInPain(player) and player.mo.state != S_PLAY_ROLL and P_IsObjectOnGround(player.mo)
		and not P_IsObjectInGoop(player.mo) and player.mo.state != S_PLAY_SKID) or player.forcecrouch
			if player.mo.skin == "ace"
				player.height = 30*FRACUNIT+12*FRACUNIT
			else
				player.height = 30*FRACUNIT
			end
			
			player.crouching = true
			
			player.normalspeed = 15*FRACUNIT
			player.thrustfactor = 3
			player.jumpfactor = 3*FRACUNIT/2
			
			player.acceleration = 40
		else
			player.crouching = false
			
			if not player.flying and not player.gliding and not player.dashtime
				if player.mo.skin == "ace"
					player.height = 60*FRACUNIT+24*FRACUNIT
				else
					player.height = 60*FRACUNIT
				end
			end
			
			player.normalspeed = 30*FRACUNIT
			player.thrustfactor = 5
			player.jumpfactor = 227*FRACUNIT/200
		end
		
		-- Ceiling Height Check
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and player.mo.ceilingz - player.mo.floorz < FixedMul(48*FRACUNIT, player.mo.scale)
			player.forcecrouch = true
		else
			player.forcecrouch = false
		end
		
		-- Dash
		
		if player.xtap and not player.dashtime and not player.dashdelay
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			player.dashtime = 25
			player.dashdelay = 100
			
			P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + player.mo.height/4)
			
			S_StartSound(player.mo, sfx_mswing)
		end
		
		if player.dashtime and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			P_InstaThrust(player.mo, player.drawangle, 48*FRACUNIT)
			
			if player.mo.skin == "ace"
				player.height = 30*FRACUNIT+12*FRACUNIT
			else
				player.height = 30*FRACUNIT
			end
			
			player.pflags = $|PF_DRILLING
			
			if not player.flying
				if (player.cmd.buttons & B)
					player.mo.momz = max($-1*FRACUNIT, -18*FRACUNIT)
				else
					if player.mo.momz < 0
						player.mo.momz = min($+1*FRACUNIT, 0)
					else
						player.mo.momz = max($-1*FRACUNIT, 0)
					end
				end
			end
			
			player.dashtime = max($-1, 0)
		else
			player.pflags = $&~PF_DRILLING
			
			if player.dashdelay
				player.dashdelay = max($-1, 0)
			end
		end
		
		-- Fire
		
		if player.rttap and player.playerstate == PST_LIVE
		and not P_PlayerInPain(player) and player.mo.state != S_PLAY_ROLL
		and not (gametyperules & GTR_RINGSLINGER)
		and (not player.wiz or player.wiz and not player.wiz.shield)
			local Fireball = P_SPMAngle(player.mo, MT_ADFIREBALL, player.drawangle, fpaim)
			
			if Fireball and Fireball.valid
				Fireball.scale = 1*FRACUNIT/2
				Fireball.scalespeed = 1*FRACUNIT/8
				Fireball.destscale = 1*FRACUNIT
				Fireball.tracer = player.mo
			end
			
			//FIRESPRITES
			
		end
		
		-- State Machine
		
		if player.flying
			if abs(player.mo.momx) >= 16*FRACUNIT or abs(player.mo.momy) >= 16*FRACUNIT
				player.mo.state = S_PLAY_FLY
			else
				player.mo.state = S_PLAY_FALL
			end
		elseif player.gliding
			if abs(player.mo.momx) >= 16*FRACUNIT or abs(player.mo.momy) >= 16*FRACUNIT
				player.mo.state = S_PLAY_GLIDE
			else
				player.mo.state = S_PLAY_FALL
			end
		elseif player.crouching
			if player.cmd.sidemove != 0 or not TwoD and not player.mo.currentaxis and player.cmd.forwardmove != 0
				player.mo.state = S_PLAY_ACECRAWL
			else
				player.mo.state = S_PLAY_ACECROUCH
			end
			
			if not srb2p
				player.powers[pw_strong] = STR_NONE
			end
		elseif player.dashtime
			player.mo.state = S_PLAY_DASH
			
			if not srb2p
				player.powers[pw_strong] = STR_ANIM|STR_PUNCH
			end
		else
			if player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_DASH
				player.mo.state = S_PLAY_FALL
			end
			
			if not srb2p
				player.powers[pw_strong] = STR_NONE
			end
		end
	end
end)

-- Player Attacks

addHook("PlayerCanDamage", function(player)
	if player.mo.valid and (player.mo.skin == "draco"
	or (player.mo.skin == "ace" and player.wiz and player.wiz.ondragon
	and player.wiz.dragon and player.wiz.dragon.valid))
		if player.dashtime
			return true
		end
	end
end)

addHook("MobjThinker", function(spawner)
	if spawner and spawner.valid
		if spawntime == 1
			if spawner.tracer.player.wiz.dragon and spawner.tracer.player.wiz.dragon.valid
				P_RemoveMobj(spawner.tracer.player.wiz.dragon)
			end
		elseif not spawntime
			spawner.tracer.player.wiz.dragon = P_SpawnMobj(spawner.x, spawner.y, spawner.z, MT_ACEDRAGON)
			
			if spawner.tracer and spawner.tracer.valid
				spawner.tracer.player.wiz.dragon.target = spawner.tracer
				spawner.tracer.player.wiz.dragon.angle = R_PointToAngle2(spawner.tracer.player.wiz.dragon.x, spawner.tracer.player.wiz.dragon.y, spawner.tracer.x, spawner.tracer.y)
			end
			
			spawning = false
			spawntime = 100
		end
		
		local dist = P_AproxDistance(P_AproxDistance(spawner.tracer.x - spawner.x, spawner.tracer.y - spawner.y), spawner.tracer.z - spawner.z)
		
		if not spawning or (dist > 512*spawner.scale)
			P_KillMobj(spawner)
		end
	end
end, MT_ACEDRAGON_SPAWNER)

addHook("MobjThinker", function(emerald)
	if emerald and emerald.valid
		if emerald.tracer and emerald.tracer.valid
			P_MoveOrigin(emerald,
			emerald.tracer.x + P_ReturnThrustX(emerald, emerald.angle * emerald.number, (48 + 50 - duration/8) * emerald.scale),
			emerald.tracer.y + P_ReturnThrustY(emerald, emerald.angle * emerald.number, (48 + 50 - duration/8) * emerald.scale),
			emerald.tracer.z + duration*FRACUNIT/16)
			
			emerald.angle = $ + FixedAngle(duration*FRACUNIT/16) / emerald.number
			
			duration = $+1
		else
			emerald.destscale = 0
			
			if emerald.scale <= 1*FRACUNIT/96
				P_KillMobj(emerald)
				spawntime = 100
				duration = 0
			end
		end
	end
end, MT_ACEDRAGON_CHAOSEMERALD)

-- Fired Fireball

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid and mobj.tracer
	and mobj.tracer.player and mobj.tracer.player.valid
		//if 
			
		//end
		
		mobj.info.speed = 30*FRACUNIT + mobj.tracer.player.speed
	end
end, MT_ADFIREBALL)

local function FireballCollide(mobj, target)
	if not target or not target.valid or not mobj or not mobj.valid
	or not (mobj.z <= target.z + target.height and target.z <= mobj.z + mobj.height) return end
	if not mobj.tracer or not mobj.tracer.valid or mobj.tracer == target return false end
	if mobj.tracer.player.wiz and target == mobj.tracer.player.wiz.dragon return false end
	
	if target and target.valid
		if (target.type == MT_SPIKE or target.type == MT_WALLSPIKE
		or target.type == MT_SALOONDOOR or target.type == MT_SALOONDOORCENTER) -- Here's another character that can do the ACZ2 Minecart skip.
		and mobj.type == MT_ADFIREBALL
			if target.type == MT_SALOONDOOR
				P_SpawnMobjFromMobj(target, 0, 0, target.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height - mobj.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height/2 + mobj.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height/2 - mobj.height, MT_WOODDEBRIS)
				
				S_StartSound(mo, sfx_wbreak)
			end
			
			P_KillMobj(target, mobj)
		end
	end
	
	if target and target.valid
		if not target.player and not target.burning
		and not (target.flags & MF_FIRE) and ((target.flags & MF_SCENERY)
		or (target.flags & MF_ENEMY) or target.type == MT_FLAMEHOLDER
		or target.type == MT_TORCHFLOWER)
			local Height
			if target.type == MT_FLAMEHOLDER or target.type == MT_TORCHFLOWER
				Height = target.height
			else
				Height = target.height/4
			end
			
			local Flame = P_SpawnMobj(target.x, target.y, target.z + Height, MT_FLAME)
			Flame.flags = MF_NOGRAVITY|MF_FIRE
			Flame.target = target
			
			if target.type != MT_FLAMEHOLDER and target.type != MT_TORCHFLOWER
				Flame.fuse = TICRATE*2
			end
			
			S_StartSound(target, sfx_s1b3)
			target.burning = true
		end
		
		if (target.flags & MF_FIRE)
			mobj.flags = $&~MF_MISSILE
		end
	end
end

addHook("MobjCollide", FireballCollide, MT_ADFIREBALL)
addHook("MobjMoveCollide", FireballCollide, MT_ADFIREBALL)