-- Fairy Init

freeslot("MT_ACEFAIRY", "SPR_FFLT", "S_ACEFAIRY_FLOAT", "SPR_FWAT", "S_ACEFAIRY_WAIT",
"SPR_FGID", "S_ACEFAIRY_GLIDE", "SPR_FFLY", "S_ACEFAIRY_FLY", "SPR_FPNT", "S_ACEFAIRY_POINT",
"SPR_FSHD", "S_ACEFAIRY_SHIELD", "SPR_FPAN", "S_ACEFAIRY_PAIN", "SPR_FLOW", "S_ACEFAIRY_LOW",
"SPR_FDED", "S_ACEFAIRY_DEAD", "SPR_FDRN", "S_ACEFAIRY_DRWN", "SPR_FROL", "S_ACEFAIRY_ROLL",
"MT_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE_POP")

mobjinfo[MT_ACEFAIRY] =
{
	spawnstate = S_ACEFAIRY_FLOAT,
	painstate = S_ACEFAIRY_PAIN,
	deathstate = S_ACEFAIRY_DEAD,
	xdeathstate = S_ACEFAIRY_DRWN,
	spawnhealth = 3,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SHOOTABLE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_ACEFAIRY_FLOAT] = {SPR_FFLT, nil, 105, nil, 0, 0, S_ACEFAIRY_WAIT}
states[S_ACEFAIRY_WAIT] = {SPR_FWAT, FF_ANIMATE, -1, nil, 3, 16, S_NULL}
states[S_ACEFAIRY_GLIDE] = {SPR_FGID, FF_ANIMATE, -1, nil, 7, 4, S_NULL}
states[S_ACEFAIRY_FLY] = {SPR_FFLY, FF_ANIMATE, -1, nil, 3, 2, S_NULL}
states[S_ACEFAIRY_POINT] = {SPR_FPNT, nil, 10, nil, 0, 0, S_ACEFAIRY_FLOAT}
states[S_ACEFAIRY_SHIELD] = {SPR_FSHD, nil, 4, nil, 0, 0, S_ACEFAIRY_SHIELD}
states[S_ACEFAIRY_PAIN] = {SPR_FPAN, nil, 4, nil, 1, 4, S_ACEFAIRY_FLOAT}
states[S_ACEFAIRY_LOW] = {SPR_FLOW, nil, 4, nil, 0, 0, S_ACEFAIRY_FLOAT}
states[S_ACEFAIRY_DEAD] = {SPR_FDED, nil, -1, nil, 0, 0, S_NULL}
states[S_ACEFAIRY_DRWN] = {SPR_FDRN, nil, -1, nil, 0, 0, S_NULL}
states[S_ACEFAIRY_ROLL] = {SPR_FROL, FF_ANIMATE, -1, nil, 5, 2, S_NULL}

mobjinfo[MT_ACEFAIRY_BUBBLE] =
{
	spawnstate = S_ACEFAIRY_BUBBLE,
	deathstate = S_ACEFAIRY_BUBBLE_POP,
	spawnhealth = 1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
states[S_ACEFAIRY_BUBBLE] = {SPR_BUBS, K, -1, nil, 0, 0}
states[S_ACEFAIRY_BUBBLE_POP] = {SPR_BUBS, 0, 0, nil, 0, 0, S_NULL}

-- Fairy Setup

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.realmo and player.wiz
			if player.wiz.fairy and player.wiz.fairy.valid and player.wiz.fairy.target
				local player = player.wiz.fairy.target.player
				
				-- Point
				
				if player.ytap and not player.wiz.fairy.point
				and not player.wiz.shield and player.powers[pw_carry] != CR_ZOOMTUBE
				and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
					player.wiz.fairy.point = 50
				end
				
				if player.wiz.fairy.point
					player.wiz.fairy.point = $-1
				end
				
				if player.wiz.shield or player.powers[pw_carry] == CR_ZOOMTUBE
					if player.wiz.fairy.point > 1
						player.wiz.fairy.point = 1
					end
				end
				
				-- Shield
				
				local LT = BT_CUSTOM1|BT_FIRENORMAL
				
				player.wiz.parry = player.wiz.parrytime > 0
				player.wiz.parrytime = max($-1, 0)
				
				if (player.cmd.buttons & LT) and player.playerstate == PST_LIVE
				and not P_PlayerInPain(player) and not player.wiz.shieldrecharge 
				and not player.wiz.shielddelay and not player.wiz.casting
				and player.powers[pw_carry] != CR_ZOOMTUBE
				and not player.gotflag and not player.exiting
				or player.playerstate == PST_LIVE and (player.mo.state != S_PLAY_PAIN
				or (player.pflags & PF_SLIDING)) and player.powers[pw_flashing]
					if player.powers[pw_flashing]
						player.wiz.shieldtime = player.powers[pw_flashing]
					end
					
					if player.wiz.shieldtime > 0
						player.wiz.shield = true
						player.wiz.shieldtime = $-1
						
						if not player.wiz.shieldorb or not player.wiz.shieldorb.valid
							if player.lttap
								player.wiz.parrytime = 2
							end
							
							player.wiz.shieldorb = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACESHIELD)
							
							if player.wiz.shieldorb and player.wiz.shieldorb.valid
								player.wiz.shieldorb.scale = 1*FRACUNIT/4
								player.wiz.shieldorb.scalespeed = 1*FRACUNIT/4
								player.wiz.shieldorb.target = player.mo
								
								S_StartSound(mobj, sfx_shield)
							end
						end
					else
						player.wiz.shieldrecharge = true
					end
				else
					if player.wiz.shield
						player.wiz.shield = false
						player.wiz.shielddelay = 15
						
						S_StartSound(mobj, sfx_ngskid)
					end
					
					player.wiz.shieldtime = min($+1, 100)
					
					if player.wiz.shieldorb and player.wiz.shieldorb.valid
						player.wiz.shieldorb.destscale = 0
						
						if player.wiz.shieldorb.scale <= 1*FRACUNIT/96
							P_RemoveMobj(player.wiz.shieldorb)
						end
					end
				end
				
				if player.lttap and player.wiz.shieldrecharge
					player.wiz.shieldrecharge = false
				end
				
				player.wiz.shielddelay = max($-1, 0)
			else
				player.wiz.fairy = P_SpawnMobjFromMobj(player.mo,
				player.rmomx + FixedMul(cos(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustX(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.rmomy + FixedMul(sin(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustY(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.mo.momz + player.mo.height, MT_ACEFAIRY)
				
				if player.realmo
					player.wiz.fairy.target = player.mo
				end
				
				player.wiz.fairy.newx = player.wiz.fairy.x
				player.wiz.fairy.newy = player.wiz.fairy.y
				player.wiz.fairy.newz = player.wiz.fairy.z
				
				player.wiz.fairy.side = -1
				
				player.wiz.fairy.sidex = P_ReturnThrustX(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.wiz.fairy.target.scale))
				player.wiz.fairy.sidey = P_ReturnThrustY(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.wiz.fairy.target.scale))
				
				player.wiz.fairy.point = 0
			end
		end
	end
end)

-- Fairy Thinker

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.target and mobj.target.valid and mobj.target.player.wiz
		and (mobj.target.skin == "ace" or mobj.target.player.wiz.allowed)
			-- Color
			
			if not G_GametypeHasTeams()
				mobj.color = R_GetColorByName(mobj.target.player.skincolor+15)
			else
				mobj.color = R_GetColorByName(mobj.target.player.skincolor)
			end
			
			-- Movement
			
			if mobj.health
				if not mobj.tracer or mobj.point
					if mobj.target.player.wiz.wallsliding
						mobj.newx = mobj.target.x - FixedMul(cos(mobj.target.player.drawangle), mobj.target.radius - mobj.radius - 50*FRACUNIT)
						mobj.newy = mobj.target.y - FixedMul(sin(mobj.target.player.drawangle), mobj.target.radius - mobj.radius - 50*FRACUNIT)
						
						mobj.side = -mobj.side
					else
						mobj.newx = mobj.target.x + FixedMul(cos(mobj.target.player.drawangle), mobj.target.radius - mobj.radius - 50*FRACUNIT)
						mobj.newy = mobj.target.y + FixedMul(sin(mobj.target.player.drawangle), mobj.target.radius - mobj.radius - 50*FRACUNIT)
					end
					
					if mobj.target.player.powers[pw_carry] != CR_ZOOMTUBE
						if not (mobj.eflags & MFE_VERTICALFLIP)
							mobj.newz = mobj.target.z + mobj.target.height
						else
							mobj.newz = mobj.target.z - mobj.height
						end
					else
						mobj.newz = mobj.target.z
					end
					
					if mobj.target.player.playerstate == PST_LIVE and not (mobj.target.flags2 & MF2_TWOD)
					and mobj.target.player.powers[pw_carry] != CR_NIGHTSMODE and mobj.target.player.powers[pw_carry] != CR_ZOOMTUBE
						if leveltime % (12*TICRATE) == 0 and not mobj.target.player.wiz.wallsliding
							mobj.side = P_RandomChance(FRACUNIT/2) and -1 or 1
						end
						
						mobj.sidex = ease.inoutsine(1*FRACUNIT/12, mobj.sidex, P_ReturnThrustX(mobj, mobj.angle - ANGLE_90 * mobj.side, FixedMul(50*FRACUNIT, mobj.target.scale)))
						mobj.sidey = ease.inoutsine(1*FRACUNIT/12, mobj.sidey, P_ReturnThrustY(mobj, mobj.angle - ANGLE_90 * mobj.side, FixedMul(50*FRACUNIT, mobj.target.scale)))
					else
						mobj.sidex = 0
						mobj.sidey = 0
					end
					
					if not mobj.point or not mobj.tracer
						mobj.angle = mobj.target.player.drawangle
					end
				end
			else
				mobj.newx = mobj.target.x + FixedMul(cos(mobj.target.player.drawangle), mobj.target.radius - mobj.radius - 10*FRACUNIT)
				mobj.newy = mobj.target.y + FixedMul(sin(mobj.target.player.drawangle), mobj.target.radius - mobj.radius - 10*FRACUNIT)
				
				if not (mobj.eflags & MFE_VERTICALFLIP)
					mobj.newz = mobj.target.z + mobj.target.height/4
				else
					mobj.newz = mobj.target.z - mobj.height/4
				end
				
				mobj.sidex = 0
				mobj.sidey = 0
				
				if not mobj.point or not mobj.tracer
					mobj.angle = mobj.target.player.drawangle
				end
			end
			
			-- Tracker
			
			if mobj.tracer and mobj.tracer.valid and (ARTH_Ace.AceCollectible[mobj.tracer.type] or mobj.tracer.type == MT_ACEFLOWER)
				if mobj.health and not mobj.point and ARTH_Ace.AceCollectible[mobj.tracer.type][1]
					mobj.newx = mobj.tracer.x
					mobj.sidex = 0
					mobj.newy = mobj.tracer.y
					mobj.sidey = 0
					mobj.newz = mobj.tracer.z
				end
				
				mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.tracer.x, mobj.tracer.y)
				
				local dist = P_AproxDistance(P_AproxDistance(mobj.x - mobj.target.x, mobj.y - mobj.target.y), mobj.z - mobj.target.z)
				
				if (mobj.target.player.playerstate != PST_LIVE
				or P_PlayerInPain(mobj.target.player))
				or ((not P_CheckSight(mobj.target, mobj.tracer)
				or not (dist >= 0 and dist < 512*mobj.target.scale))
				or not mobj.tracer.health or mobj.tracer.collected
				and not mobj.point and not mobj.target.player.wiz.shield) or mobj.point == 1
					mobj.tracer = nil
				end
			else
				if not P_PlayerInPain(mobj.target.player) and not mobj.target.player.wiz.shield and mobj.target.player.powers[pw_carry] != CR_ZOOMTUBE
					if not mobj.point and mobj.health
						searchBlockmap("objects", function(mo, collectible)
							if collectible and collectible.valid
								if ((ARTH_Ace.AceCollectible[collectible.type] and ARTH_Ace.AceCollectible[collectible.type][1])
								or (collectible.type == MT_REDTEAMRING and mo.target.player.ctfteam == 1)
								or (collectible.type == MT_BLUETEAMRING and mo.target.player.ctfteam == 2))
									local dist1 = P_AproxDistance(P_AproxDistance(collectible.x - mo.target.x, collectible.y - mo.target.y), collectible.z - mo.target.z)
									local dist2 = P_AproxDistance(P_AproxDistance(mo.x - collectible.x, mo.y - collectible.y), mo.z - collectible.z)
									
									if not mo.tracer and P_CheckSight(mo.target, collectible)
									and mo.target.player.playerstate == PST_LIVE and not P_PlayerInPain(mo.target.player)
									and mo.target.player.powers[pw_carry] != CR_NIGHTSMODE and not collectible.tracer
									and collectible.health and not collectible.collected
										if ((dist1 >= 0 and dist1 < 256*mo.target.scale)
										or (dist2 >= 0 and dist2 < 128*mo.target.scale))
											mo.tracer = collectible
											collectible.tracer = mo
										end
									end
								end
							else
								return
							end
						end, mobj,
						mobj.target.x - RING_DIST, mobj.target.x + RING_DIST,
						mobj.target.y - RING_DIST, mobj.target.y + RING_DIST)
					elseif mobj.point
						searchBlockmap("objects", function(mo, collectible)
							if collectible and collectible.valid
								if (mo.health and (ARTH_Ace.AceCollectible[collectible.type] and ARTH_Ace.AceCollectible[collectible.type][2])
								or ((collectible.type == MT_REDTEAMRING or collectible.type == MT_RING_REDBOX) and mo.target.player.ctfteam == 1)
								or ((collectible.type == MT_BLUETEAMRING or collectible.type == MT_RING_BLUEBOX) and mo.target.player.ctfteam == 2))
								or (not mo.health and collectible.type == MT_ACEFLOWER)
									if not mo.tracer and mo.target.player.playerstate == PST_LIVE and not P_PlayerInPain(mo.target.player)
									and mo.target.player.powers[pw_carry] != CR_NIGHTSMODE and not collectible.tracer
									and collectible.health and not collectible.collected
										A_FindTracer(mo, collectible.type)
									end
								end
							else
								return
							end
						end, mobj,
						mobj.target.x - RING_DIST*8, mobj.target.x + RING_DIST*8,
						mobj.target.y - RING_DIST*8, mobj.target.y + RING_DIST*8)
					end
				end
			end
			
			-- Thinker
			
			if mobj.target.player.playerstate != PST_DEAD
				if mobj.health
					mobj.movedir = $ + FixedAngle(8*FRACUNIT)
					
					local movespeed
					local dist = P_AproxDistance(P_AproxDistance(mobj.x - mobj.target.x, mobj.y - mobj.target.y), mobj.z - mobj.target.z)
					if (dist >= 0 and dist < 1024*mobj.target.scale)
						movespeed = 1*FRACUNIT/3
					else
						movespeed = 1*FRACUNIT
					end
					
					P_MoveOrigin(mobj,
					ease.inoutsine(movespeed, mobj.x, mobj.newx + mobj.sidex),
					ease.inoutsine(movespeed, mobj.y, mobj.newy + mobj.sidey),
					ease.inoutsine(movespeed, mobj.z, mobj.newz)
					+ FixedMul(cos(mobj.movedir), 1*FRACUNIT/2))
					
					local Shine = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_THOK)
					
					P_MoveOrigin(Shine, mobj.x, mobj.y, mobj.z + (P_MobjFlip(mobj) < 0 and -mobj.height*3 or 0))
					
					Shine.color = mobj.color
					
					local FADEFLAG = {FF_TRANS90, FF_TRANS80, FF_TRANS70, FF_TRANS60}
					Shine.frame = FF_FULLBRIGHT|FADEFLAG[mobj.health]
					
					Shine.scale = mobj.scale
					Shine.scalespeed = 1*FRACUNIT/4
					Shine.destscale = 0
				else
					mobj.movedir = 0
					
					P_MoveOrigin(mobj, mobj.newx, mobj.newy, mobj.newz)
				end
			else
				if not (mobj.flags & MF_NOCLIP)
					mobj.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
					P_SetObjectMomZ(mobj, mobj.target.momz)
				end
			end
			
			-- State Machine
			
			if mobj.target.player.playerstate != PST_DEAD
				if mobj.target.player.powers[pw_carry] != CR_ZOOMTUBE
					if mobj.health
						if abs(mobj.target.player.speed) < 10*FRACUNIT
						and not mobj.tracer and not mobj.point
							if mobj.state != S_ACEFAIRY_FLOAT and mobj.state != S_ACEFAIRY_WAIT
								mobj.state = S_ACEFAIRY_FLOAT
							end
						elseif abs(mobj.target.player.speed) >= 10*FRACUNIT
						and abs(mobj.target.player.speed) < 25*FRACUNIT
						and not mobj.tracer and not mobj.point
							if mobj.state != S_ACEFAIRY_GLIDE
								mobj.state = S_ACEFAIRY_GLIDE
							end
						elseif abs(mobj.target.player.speed) >= 25*FRACUNIT
						or mobj.tracer and not mobj.point
							if mobj.state != S_ACEFAIRY_FLY
								mobj.state = S_ACEFAIRY_FLY
							end
						end
					else
						mobj.state = S_ACEFAIRY_LOW
					end
					
					if mobj.tracer and mobj.point
						mobj.state = S_ACEFAIRY_POINT
					end
					
					if mobj.target.player.wiz.shield and not mobj.point
						mobj.state = S_ACEFAIRY_SHIELD
					end
				else
					if mobj.state != S_ACEFAIRY_ROLL
						mobj.state = S_ACEFAIRY_ROLL
					end
				end
				
				if P_PlayerInPain(mobj.target.player)
					mobj.state = S_ACEFAIRY_PAIN
				end
			else
				if mobj.target.player.powers[pw_underwater] or mobj.target.player.powers[pw_spacetime]
					mobj.state = S_ACEFAIRY_DRWN
				else
					mobj.state = S_ACEFAIRY_DEAD
				end
			end
			
			-- Visual
			
			if mobj.target.player.playerstate != PST_DEAD and mobj.health
				mobj.frame = $|FF_FULLBRIGHT
			else
				mobj.frame = $&~FF_FULLBRIGHT
			end
			
			if P_MobjFlip(mobj.target) > 0
				mobj.flags2 = $&~MF2_OBJECTFLIP
				mobj.eflags = $&~MFE_VERTICALFLIP
			else
				mobj.flags2 = $|MF2_OBJECTFLIP
				mobj.eflags = $|MFE_VERTICALFLIP
			end
			
			// Flash player after being hit. -- (From SRB2 source code)
			if (mobj.target.player.powers[pw_flashing] > 0 and mobj.target.player.powers[pw_flashing] < flashingtics
			and (leveltime & 1) and mobj.target.player.playerstate == PST_LIVE)
				mobj.flags2 = $|MF2_DONTDRAW
			else
				mobj.flags2 = $&~MF2_DONTDRAW
			end
			
			mobj.scale = mobj.target.scale
			
			-- Bubble
			
			if (mobj.eflags & MFE_UNDERWATER)
				if not (mobj.bubble and mobj.bubble.valid)
					mobj.bubble = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_ACEFAIRY_BUBBLE)
					mobj.bubble.target = mobj
				else
					A_CapeChase(mobj.bubble)
				end
			else
				if mobj.bubble and mobj.bubble.valid
					P_KillMobj(mobj.bubble)
				end
			end
			
			-- Health
			
			if not ARTH_Ace.AceHealth
				mobj.health = mobj.target.health
			end
		else
			if mobj.bubble and mobj.bubble.valid
				P_KillMobj(mobj.bubble)
			end
			
			P_RemoveMobj(mobj)
		end
	end
end, MT_ACEFAIRY)

addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid
		return false
	end
end, MT_ACEFAIRY)

-- Fariy Collect

local function FariyCollect(mobj, collectible)
	if mobj and mobj.valid and mobj.target and mobj.target.valid
	and collectible and collectible.valid
	and (ARTH_Ace.AceCollectible[collectible.type]
	and ARTH_Ace.AceCollectible[collectible.type][1])
		if mobj.tracer and collectible == mobj.tracer
		and (mobj.z <= collectible.z + collectible.height and mobj.z + mobj.height >= collectible.z)
		and collectible.health and not collectible.collected
			mobj.tracer = nil
			
			collectible.collected = true
			collectible.target = mobj.target
			collectible.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			S_StartSound(mobj, sfx_thok)
			return false
		end
	end
end

addHook("MobjCollide", FariyCollect, MT_ACEFAIRY)
addHook("MobjMoveCollide", FariyCollect, MT_ACEFAIRY)

local function CollectibleThinker(collectible)
	if collectible and collectible.valid and collectible.health
	and ARTH_Ace.AceCollectible[collectible.type]
		if collectible.target and collectible.collected
			A_HomingChase(collectible, 30*FRACUNIT+collectible.target.player.speed)
			
			if not collectible.health
				collectible.collected = false
				collectible.target = nil
				collectible.tracer = nil
			end
		end
	end
end

addHook("MobjThinker", CollectibleThinker)

freeslot("MT_ACESHIELD", "S_ACESHIELD_ON", "S_ACESHIELD", "S_ACESHIELD_OFF", "SPR_ASHD")

-- Player Shield

mobjinfo[MT_ACESHIELD] =
{
	doomednum = -1,
	spawnstate = S_ACESHIELD,
	deathstate = S_ACESHIELD_OFF,
	//seesound = sfx_shield,
	//deathsound = sfx_ngskid,
	spawnhealth = 100,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_ACESHIELD_ON] = {SPR_ASHD, 0, 0, nil, 0, 0, S_ACESHIELD}
states[S_ACESHIELD] = {SPR_ASHD, FF_ANIMATE|FF_FULLBRIGHT|FF_TRANS50, -1, nil, 9, 4}
states[S_ACESHIELD_OFF] = {SPR_ASHD, 0, 0, nil, 0, 0, S_NULL}

-- Shield Behavior

addHook("MobjThinker", function(shield)
	if shield and shield.valid
		if shield.target and shield.target.valid and shield.target.player.wiz
		and shield.target.player.wiz.fairy and shield.target.player.wiz.fairy.valid
			shield.color = R_GetColorByName(shield.target.player.wiz.fairy.color)
			
			local ShieldZ
			if P_MobjFlip(shield.target) > 0
				ShieldZ = shield.target.z + 2*FRACUNIT
				
				shield.flags2 = $&~MF2_OBJECTFLIP
				shield.eflags = $&~MFE_VERTICALFLIP
			else
				ShieldZ = shield.target.z - 2*FRACUNIT
				
				shield.flags2 = $|MF2_OBJECTFLIP
				shield.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(shield, shield.target.x, shield.target.y, ShieldZ)
			
			shield.angle = shield.target.player.drawangle
			
			if shield.target.skin == "ace"
				shield.destscale = shield.target.player.shieldscale
			else
				shield.destscale = shield.target.player.shieldscale*3/2
			end
		else
			P_RemoveMobj(shield)
		end
	end
end, MT_ACESHIELD)

local function ShieldCollide(shield, mobj)
	if not (mobj and mobj.valid and shield and shield.valid)
	or not ((mobj.flags & MF_ENEMY) /*or (mobj.flags & MF_MISSILE)
	or (mobj.flags & MF_PAIN)*/ or (mobj.flags & MF_PUSHABLE))
	or shield.target == mobj //or mobj.reflected
		return
	end
	
	if mobj.z - mobj.scale <= shield.z + shield.height
	and mobj.z + mobj.height + mobj.scale >= shield.z
		local PushAngle = R_PointToAngle2(shield.target.x, shield.target.y, mobj.x, mobj.y)
		
		if shield.target.player.wiz.parry
			/*if (mobj.flags & MF_MISSILE) or (mobj.flags & MF_PAIN)
				local Momz = mobj.momz
				local Missile = mobj.type
				
				if mobj.health
					mobj.target = nil
					mobj.state = mobjinfo[Missile].spawnstate
					
					P_InstaThrust(mobj, PushAngle, mobj.info.speed)
					mobj.momz = -Momz
				else
					local mobj = P_SPMAngle(shield, Missile, PushAngle)
					mobj.momz = -Momz
					mobj.reflected = true
				end
				
				-- TODO: Reverse mace speed
				
				if not shield.parried
					S_StartSound(shield, sfx_hoop2)
					shield.parried = true
				end
				
				shield.target.player.wiz.parrytime = 2
				shield.target.player.wiz.shieldtime = $+2
			end*/
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, mobjinfo[mobj.type].speed*8*FRACUNIT)
			end
			
			S_StartSound(shield, sfx_s259)
		else
			if shield.parried
				shield.parried = false
			end
			
			if (mobj.flags & MF_MISSILE)
				P_DamageMobj(mobj)
			end
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, shield.target.player.speed+PUSHACCEL)
			end
		end
	end
end

addHook("MobjCollide", ShieldCollide, MT_ACESHIELD)
addHook("MobjMoveCollide", ShieldCollide, MT_ACESHIELD)

-- Player Protection

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.player.wiz
	and not (damagetype & DMG_DEATHMASK)
		if target.player.wiz.shield and not (damagetype and damagetype == DMG_NUKE)
		and target.player.wiz.shieldorb and target.player.wiz.shieldorb.valid
			return false
		end
	end
end, MT_PLAYER)

-- Give players a fairy (WIP)

/*local function PrintMsg(var)
	for player in players.iterate
		if player.realmo
			if var == 1
				CONS_Printf(player, "\x89\They now have a fairy.")
			elseif var == 2
				CONS_Printf(player, "\x89\They do not have a fairy anymore.")
			elseif var == 3
				CONS_Printf(player, "\x89\They already have a fairy.")
			end
			
			return
		end
	end
end

COM_AddCommand("GiveFairy", function(player, arg)
	for player in players.iterate
		if arg == "help"
			CONS_Printf(player, "\x89\A fairy can help you collect and find collectibles and can give you a shield.")
			
			if not splitscreen
				CONS_Printf(player, "\x89\You can give yourself and a bot a fairy. You can give a bot a fairy if you type; 'bot', 'ai' or their skin name beside the command.")
			else
				CONS_Printf(player, "\x89\You can give yourself and player 2 a fairy. You can give player 2 a fairy if you type; 'player 2', 'p2' beside the command.")
			end
		end
		
		if not splitscreen
			if not player.bot and (arg != "bot" and arg != "ai" and arg != (player.bot and player.mo.skin))
				if player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					CONS_Printf(player, "\x89\You now have a fairy.")
				elseif player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					CONS_Printf(player, "\x89\You do not have a fairy anymore.")
				else
					CONS_Printf(player, "\x89\You already have a fairy.")
				end
			elseif player.bot and (arg == "bot" or arg == "ai" or arg == (player.bot and player.mo.skin))
				if player.bot and player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					PrintMsg(1)
				elseif player.bot and player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					PrintMsg(2)
				elseif player.bot and player.mo.skin == "ace"
					PrintMsg(3)
				end
			elseif not player.bot and (arg == "bot" or arg == "ai" or arg == (player.bot and player.mo.skin))
				CONS_Printf(player, "\x89\There is no bot.")
			end
		else
			local player = players[1]
			
			if not player.bot and (arg != "player 2" and arg != "p2" and arg != (player.bot and player.mo.skin))
				if player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					CONS_Printf(player, "\x89\You now have a fairy.")
				elseif player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					CONS_Printf(player, "\x89\You do not have a fairy anymore.")
				else
					CONS_Printf(player, "\x89\You already have a fairy.")
				end
			elseif player.bot and (arg == "player 2" or arg != "p2" or arg == (player.bot and player.mo.skin))
				if player.bot and player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					PrintMsg(1)
				elseif player.bot and player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					PrintMsg(2)
				elseif player.bot and player.mo.skin == "ace"
					PrintMsg(3)
				end
			elseif not player.bot and (arg == "player 2" or arg != "p2" or arg == (player.bot and player.mo.skin))
				CONS_Printf(player, "\x89\Player 2 is missing.")
			end
		end
	end
end)*/