local client

local function ElementWheel(v, player)
	client = player
	
	if player.mo and player.wiz
	and player.wiz.element != nil and not player.wiz.ondragon
	and player.powers[pw_carry] != CR_NIGHTSMODE
	and not (gametyperules & GTR_RINGSLINGER)
		local ElementWheel = v.cachePatch("GUI_EWHEEL")
		
		v.drawScaled(-56*FRACUNIT, 108*FRACUNIT, FRACUNIT/2, ElementWheel, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		
		local EarthIcon = v.cachePatch("GUI_EARTH")
		local WaterIcon = v.cachePatch("GUI_WATER")
		local AirIcon = v.cachePatch("GUI_AIR")
		local FireIcon = v.cachePatch("GUI_FIRE")
		
		local Angle = FixedAngle(0)
		
		if player.wiz.element == 0
			Angle = ease.inoutsine(1*FRACUNIT, Angle, FixedAngle(0))
		elseif player.wiz.element == 1
			Angle = ease.inoutsine(1*FRACUNIT, Angle, FixedAngle(90*FRACUNIT))
		elseif player.wiz.element == 2
			Angle = ease.inoutsine(1*FRACUNIT, Angle, FixedAngle(180*FRACUNIT))
		elseif player.wiz.element == 3
			Angle = ease.inoutsine(1*FRACUNIT, Angle, FixedAngle(270*FRACUNIT))
		end
		
		local XPosE, YPosE, XPosW, YPosW, XPosA, YPosA, XPosF, YPosF
		
		XPosE = -56*FRACUNIT + FixedMul(sin(Angle + ANGLE_180), 13*FRACUNIT)
		YPosE = 108*FRACUNIT + FixedMul(cos(Angle + ANGLE_180), 13*FRACUNIT)
		
		XPosW = -56*FRACUNIT + FixedMul(sin(Angle + ANGLE_90), 13*FRACUNIT)
		YPosW = 108*FRACUNIT + FixedMul(cos(Angle + ANGLE_90), 13*FRACUNIT)
		
		XPosA = -56*FRACUNIT + FixedMul(sin(Angle), 13*FRACUNIT)
		YPosA = 108*FRACUNIT + FixedMul(cos(Angle), 13*FRACUNIT)
		
		XPosF = -56*FRACUNIT + FixedMul(sin(Angle + ANGLE_270), 13*FRACUNIT)
		YPosF = 108*FRACUNIT + FixedMul(cos(Angle + ANGLE_270), 13*FRACUNIT)
		
		v.drawScaled(XPosE, YPosE, FRACUNIT/2, EarthIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		v.drawScaled(XPosW, YPosW, FRACUNIT/2, WaterIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		v.drawScaled(XPosA, YPosA, FRACUNIT/2, AirIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		v.drawScaled(XPosF, YPosF, FRACUNIT/2, FireIcon, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
	end
end

local function AceManaBar(v, player)
	client = player
	
	if player.mo and player.wiz
	and (player.wiz.casttime != nil or player.wiz.shieldtime != nil)
	and player.powers[pw_carry] != CR_NIGHTSMODE
		local ManaBar = v.cachePatch("GUI_MANABAR")
		
		local CastFill = v.cachePatch("GUI_MANABAR_FILL")
		local ShieldFill = v.cachePatch("GUI_MANABAR_FILL")
		
		local XPosC = -61
		local XPosS = -61
		
		local YPosH
		if ARTH_Ace.AceHealth and ARTH_Ace.AceHealth.value
			YPosH = -18
		else
			YPosH = 0
		end
		
		local Color
		if not G_GametypeHasTeams()
			Color = R_GetColorByName(player.skincolor+15)
		else
			Color = R_GetColorByName(player.skincolor)
		end
		
		if not (gametyperules & GTR_RINGSLINGER) and player.wiz.casttime != nil
			v.draw(-110, -10 + YPosH, ManaBar, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			
			for i = 98, 1, -1
				if player.wiz.casttime >= i
					v.draw(XPosC, -13 + YPosH, CastFill, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_CERULEAN", player.mo.color))
				end
				XPosC = $-1
			end
		end
		
		if player.wiz.shieldtime != nil and player.wiz.fairy
			v.draw(-110, -19 + YPosH, ManaBar, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			
			for i = 98, 1, -1
				if player.wiz.shieldtime >= i
					v.draw(XPosS, -22 + YPosH, ShieldFill, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap("SKINCOLOR_PURPLE", Color))
				end
				XPosS = $-1
			end
		end
	end
end

local function HealingFlowers(v, player)
	if player.hellfireHealth return end
	
	client = player
	
	if player.mo and player.mo.skin == "ace" and player.wiz and player.wiz.fairy
	and player.powers[pw_carry] != CR_NIGHTSMODE and ARTH_Ace.AceHealth and ARTH_Ace.AceHealth.value
		local HealingFlower = v.cachePatch("GUI_HFLOWER")
		
		if player.mo.health
			if player.wiz.fairy.health >= 0
				v.drawScaled(-72*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
			
			if player.wiz.fairy.health >= 1
				v.drawScaled(-55*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
			
			if player.wiz.fairy.health >= 2
				v.drawScaled(-38*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
			
			if player.wiz.fairy.health >= 3
				v.drawScaled(-21*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
			
			if player.wiz.fairy.health == 4
				v.drawScaled(-4*FRACUNIT, 74*FRACUNIT, FRACUNIT/2, HealingFlower, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
		end
	end
end

hud.add(ElementWheel)
hud.add(AceManaBar)

if not srb2p and not pso
	hud.add(HealingFlowers)
end