-- Tables

---- Collectibles collectable by the fairy

/*ARTH_Ace.AceCollectible[name] = {collectable, pointable}

name: -- The name of the collectible.
collectable: -- If true, the fairy will collect it. If false, the fairy won't collect it.
pointable: -- If true, the fairy will point at it. If false, the fairy won't point at it.*/

if not ARTH_Ace.AceCollectible
	rawset(ARTH_Ace, "AceCollectible", {})
end

ARTH_Ace.AceCollectible[MT_RING] = {true, true}
ARTH_Ace.AceCollectible[MT_FLINGRING] = {true, true}
ARTH_Ace.AceCollectible[MT_COIN] = {true, true}
ARTH_Ace.AceCollectible[MT_FLINGCOIN] = {true, true}

ARTH_Ace.AceCollectible[MT_TOKEN] = {true, true}
ARTH_Ace.AceCollectible[MT_BLUESPHERE] = {true, true}

ARTH_Ace.AceCollectible[MT_EMBLEM] = {false, true}

ARTH_Ace.AceCollectible[MT_EMERALD1] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD2] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD3] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD4] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD5] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD6] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERALD7] = {false, true}
ARTH_Ace.AceCollectible[MT_EMERHUNT] = {false, true}

ARTH_Ace.AceCollectible[MT_RING_BOX] = {false, true}
ARTH_Ace.AceCollectible[MT_1UP_BOX] = {false, true}
ARTH_Ace.AceCollectible[MT_SCORE1K_BOX] = {false, true}
ARTH_Ace.AceCollectible[MT_SCORE10K_BOX] = {false, true}

ARTH_Ace.AceCollectible[MT_FLINGNIGHTSCHIP] = {true, true}
ARTH_Ace.AceCollectible[MT_FLINGNIGHTSSTAR] = {true, true}

ARTH_Ace.AceCollectible[MT_INFINITYRING] = {true, true}
ARTH_Ace.AceCollectible[MT_BOUNCERING] = {true, true}
ARTH_Ace.AceCollectible[MT_RAILRING] = {true, true}
ARTH_Ace.AceCollectible[MT_AUTOMATICRING] = {true, true}
ARTH_Ace.AceCollectible[MT_EXPLOSIONRING] = {true, true}
ARTH_Ace.AceCollectible[MT_SCATTERRING] = {true, true}
ARTH_Ace.AceCollectible[MT_GRENADERING] = {true, true}

ARTH_Ace.AceCollectible[MT_BOUNCEPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_RAILPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_AUTOPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_EXPLODEPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_SCATTERPICKUP] = {true, true}
ARTH_Ace.AceCollectible[MT_GRENADEPICKUP] = {true, true}

-- Functions

---- Healing for Ace's Health System

/*ARTH_Ace.AceHeal(player, sound)

player: -- The player.
sound: -- If true or nil, it will play the healing sound. If false, it won't play the healing sound.*/

if not ARTH_Ace.AceHeal
	rawset(ARTH_Ace, "AceHeal", function(player, sound) 
		if player and player.valid
		and player.wiz.fairy and player.wiz.fairy.valid
		and player.wiz.fairy.target.skin == "ace"
		and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.powers[pw_carry] != CR_NIGHTSFALL
			if player.wiz.fairy.health < 4
				player.wiz.fairy.health = $+1
				
				if player.wiz.dragon and player.wiz.dragon.valid
					player.wiz.dragon.health = $+1
				end
				
				if sound != false
					S_StartSound(special, sfx_hoop1)
				end
			end
		end
	end)
end

/*ARTH_Ace.SpawnFlower(mobj, player, target)

mobj: -- The object you're spawning the flower from.
player: -- The player.
target: -- If true, it will home in on the player. If false or nil, it won't home in on the player.*/

if not ARTH_Ace.SpawnFlower
	rawset(ARTH_Ace, "SpawnFlower", function(mobj, player, target)
		local Flower = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ACEFLOWER)
		
		if P_MobjFlip(mobj) > 0
			Flower.flags2 = $&~MF2_OBJECTFLIP
			Flower.eflags = $&~MFE_VERTICALFLIP
		else
			Flower.flags2 = $|MF2_OBJECTFLIP
			Flower.eflags = $|MFE_VERTICALFLIP
		end
		
		if target
			Flower.target = player.mo
		end
	end)
end

-- Commands

local OnOff = "On" if srb2p or pso OnOff = "Off" end

---- Ace's Health System

if not ARTH_Ace.AceHealth
	rawset(ARTH_Ace, "AceHealth", CV_RegisterVar({
		name = "acehealth",
		defaultvalue = OnOff,
		flags = CV_NETVAR|CV_CALL,
		PossibleValue = CV_OnOff,
		func = function(cv)
			if not srb2p and not pso
				if cv.value
					print("\x84\Ace's Health System is on.")
				else
					print("\x84\Ace's Health System is off.")
				end
			else
				print("\x85\Ace's Health System doesn't work here.")
			end
		end
	}))
end

---- Ace's Tips

/*if not ARTH_Ace.AceTips
	rawset(ARTH_Ace, "AceTips", CV_RegisterVar({
		name = "acetips",
		defaultvalue = OnOff,
		flags = CV_NETVAR|CV_CALL,
		PossibleValue = CV_OnOff,
		func = function(cv)
			if not srb2p and not pso
				if cv.value
					print("\x89\Ace's Tips is on.")
				else
					print("\x89\Ace's Tips is off.")
				end
			else
				print("\x85\Ace's Tips doesn't work here.")
			end
		end
	}))
end*/