-- Player Health

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.player.hellfireHealth return end
	
	if target.player and target.player.valid and target.skin == "ace"
	and target.player.powers[pw_carry] != CR_NIGHTSMODE
	and target.player.powers[pw_carry] != CR_NIGHTSFALL
	and target.player.wiz.fairy and target.player.wiz.fairy.valid
	and not target.player.powers[pw_shield] and not P_PlayerInPain(target.player)
	and not target.player.powers[pw_super] and ARTH_Ace.AceHealth.value
		if target.player.wiz.fairy.health
			target.player.wiz.fairy.health = $-1
			
			if target.player.rings or target.player.ringweapons or target.player.powers[pw_emeralds]
				P_PlayRinglossSound(target)
				P_PlayerRingBurst(target.player)
				target.player.rings = 0
			end
			
			if (gametyperules & GTR_TEAMFLAGS) and (target.player.gotflag & (GF_REDFLAG|GF_BLUEFLAG))
				P_PlayerFlagBurst(target.player)
			end
			
			P_DoPlayerPain(target.player, source, inflictor)
		else
			P_KillMobj(target, inflictor, source, damagetype)
			
			if (source)
				if ((gametyperules & GTR_RINGSLINGER) and !(gametyperules & GTR_TAG))
					if target.player.rings or target.player.ringweapons or target.player.powers[pw_emeralds]
						P_PlayRinglossSound(target)
						P_PlayerRingBurst(target.player)
						target.player.rings = 0
					end
				end
				
				if (gametyperules & GTR_POWERSTONES)
					P_PlayerEmeraldBurst(target.player, false)
				end
			end
			
			target.player.powers[pw_emeralds] = 0
			
			P_ResetPlayer(target.player)
			
			if ((gametyperules & GTR_TEAMFLAGS) and (target.player.gotflag & (GF_REDFLAG|GF_BLUEFLAG)))
				P_PlayerFlagBurst(target.player, false)
			end
		end
		
		if damagetype == DMG_SPIKE
			S_StartSound(target, sfx_spkdth)
		elseif not target.player.rings and not target.player.ringweapons and not target.player.powers[pw_emeralds]
			P_PlayDeathSound(target)
		end
		
		return true
	end
end, MT_PLAYER)

-- Player Heal

local function TouchHeal(special, toucher)
	if special and special.valid and toucher and toucher.valid
	and toucher.player and toucher.skin == "ace"
	and toucher.player.powers[pw_carry] != CR_NIGHTSMODE
	and toucher.player.powers[pw_carry] != CR_NIGHTSFALL
	and toucher.player.wiz.fairy and toucher.player.wiz.fairy.valid
	and toucher.player.wiz.fairy.health < 4 and ARTH_Ace.AceHealth.value
	and (special.type == MT_ACEFLOWER or toucher.player.starpostnum < special.health)
		ARTH_Ace.AceHeal(toucher.player, special.type != MT_ACEFLOWER)
	else
		if special.type == MT_ACEFLOWER
			return
		end
	end
end

addHook("TouchSpecial", TouchHeal, MT_STARPOST)

-- Flower Init

freeslot("MT_ACEFLOWER", "SPR_AFWR", "S_ACEFLOWER", "SPR_AFSK", "S_ACEFLOWER_COLLECT")

mobjinfo[MT_ACEFLOWER] =
{
	spawnstate = S_ACEFLOWER,
	deathstate = S_ACEFLOWER_COLLECT,
	deathsound = sfx_hoop1,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 40*FRACUNIT,
	flags = MF_SPECIAL
}

states[S_ACEFLOWER] = {SPR_AFWR, FF_ANIMATE|FF_FULLBRIGHT|A, -1, nil, 7, 3}
states[S_ACEFLOWER_COLLECT] = {SPR_AFSK, FF_ANIMATE|FF_FULLBRIGHT|A, 18, nil, 8, 2, S_NULL}

-- Flower Spawn

---- From Enemy

addHook("MobjDeath", function(mobj, inflictor, source, damage, damagetype)
	if mobj and mobj.valid and (mobj.flags & MF_ENEMY)
	and source and source.valid and source.player and source.skin == "ace"
	and source.player.powers[pw_carry] != CR_NIGHTSMODE
	and source.player.powers[pw_carry] != CR_NIGHTSFALL
	and source.player.wiz.fairy and source.player.wiz.fairy.valid
	and ARTH_Ace.AceHealth.value
		if P_RandomChance(FRACUNIT/4)
			ARTH_Ace.SpawnFlower(mobj, source.player)
		end
	end
end)

---- From Boss

addHook("MobjDamage", function(mobj, inflictor, source, damage, damagetype)
	if mobj and mobj.valid and (mobj.flags & MF_BOSS)
	and source and source.valid and source.player and source.skin == "ace"
	and source.player.powers[pw_carry] != CR_NIGHTSMODE
	and source.player.powers[pw_carry] != CR_NIGHTSFALL
	and source.player.wiz.fairy and source.player.wiz.fairy.valid
	and ARTH_Ace.AceHealth.value
		if mobj.health and source.player.wiz.fairy.health < 4
			if not mobj.healaward
				mobj.healaward = 1
			else
				mobj.healaward = 2
			end
		else
			mobj.healaward = 0
		end
		
		if mobj.healaward == 2
			ARTH_Ace.SpawnFlower(mobj, source.player, true)
			
			if mobj.healaward == 2
				mobj.healaward = 0
			end
		end
	end
end)

-- Flower Thinker

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.health
			local Shine = P_SpawnMobjFromMobj(mobj, 0, 0, -4*FRACUNIT*P_MobjFlip(mobj), MT_THOK)
			
			P_MoveOrigin(Shine, mobj.x, mobj.y, mobj.z + (P_MobjFlip(mobj) < 0 and -4*FRACUNIT - mobj.height or 0))
			
			Shine.color = SKINCOLOR_PURPLE
			Shine.frame = FF_FULLBRIGHT|FF_TRANS70
			
			Shine.scale = mobj.scale
			Shine.scalespeed = 1*FRACUNIT/4
			Shine.destscale = 0
		end
		
		if mobj.target
			A_HomingChase(mobj, 30*FRACUNIT+mobj.target.player.speed)
		end
	end
end, MT_ACEFLOWER)

addHook("TouchSpecial", TouchHeal, MT_ACEFLOWER)