-- Buttons

local A = BT_JUMP
local B = BT_CUSTOM2
local X = BT_USE|BT_SPIN if srb2p X = BT_CUSTOM3 end
local Y = BT_CUSTOM3 if srb2p Y = 0 end
local LB = BT_WEAPONPREV
local RB = BT_WEAPONNEXT
local LT = BT_CUSTOM1|BT_FIRENORMAL
local RT = BT_ATTACK
local BACK = BT_TOSSFLAG

local function TAPPING(player)
	for player in players.iterate
		if player.realmo.skin == "ace" or player.realmo.skin == "draco" or player.wiz
			if not (player.cmd.buttons & A)
				player.atapready = true
				player.atap = false
			elseif player.atapready then
				player.atap = true
				player.atapready = false
			else
				player.atap = false
			end
			
			if not (player.cmd.buttons & B)
				player.btapready = true
				player.btap = false
			elseif player.btapready then
				player.btap = true
				player.btapready = false
			else
				player.btap = false
			end
			
			if not (player.cmd.buttons & X)
				player.xtapready = true
				player.xtap = false
			elseif player.xtapready then
				player.xtap = true
				player.xtapready = false
			else
				player.xtap = false
			end
			
			if not (player.cmd.buttons & Y)
				player.ytapready = true
				player.ytap = false
			elseif player.ytapready then
				player.ytap = true
				player.ytapready = false
			else
				player.ytap = false
			end
			
			if not (player.cmd.buttons & LB)
				player.lbtapready = true
				player.lbtap = false
			elseif player.lbtapready then
				player.lbtap = true
				player.lbtapready = false
			else
				player.lbtap = false
			end
			
			if not (player.cmd.buttons & RB)
				player.rbtapready = true
				player.rbtap = false
			elseif player.rbtapready then
				player.rbtap = true
				player.rbtapready = false
			else
				player.rbtap = false
			end
			
			if not (player.cmd.buttons & LT)
				player.lttapready = true
				player.lttap = false
			elseif player.lttapready then
				player.lttap = true
				player.lttapready = false
			else
				player.lttap = false
			end
			
			if not (player.cmd.buttons & RT)
				player.rttapready = true
				player.rttap = false
			elseif player.rttapready then
				player.rttap = true
				player.rttapready = false
			else
				player.rttap = false
			end
			
			if not (player.cmd.buttons & BACK)
				player.backtapready = true
				player.backtap = false
			elseif player.backtapready then
				player.backtap = true
				player.backtapready = false
			else
				player.backtap = false
			end
		end
	end
end

addHook("ThinkFrame", TAPPING)

-- Custom Functions

local function P_IsObjectInFan(mo)
	if mo.subsector and mo.subsector.sector
		local InFan = false
		if mo.subsector.sector.special == 20480
			InFan = true
		elseif not InFan
			for fof in mo.subsector.sector.ffloors()
				if fof.sector and fof.sector.special == 20480
				and ((mo.z + mo.height > fof.bottomheight) and (mo.z < fof.topheight))
					InFan = true
				end
			end
		end
		
		return InFan
	end
end

-- Player Spawn

addHook("PlayerSpawn", function(player)
	player.wiz = nil
end)

-- Elemental Jump Abilities

---- Boulder Jump
------ R.I.P Earth Platform 2023 - 2024

local function BoulderJump(player)
	if player.mo.valid and player.mo.skin == "ace"
	and player.wiz.jumpability and player.wiz.jumpabilitytime == 35
		P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
			
		player.wiz.jumpabilitytime = 10
		
		local Boulder = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEBOULDER)
		
		Boulder.tracer = player.mo
		
		P_SetObjectMomZ(Boulder, -5*FRACUNIT)
		S_StartSound(player.mo, sfx_s3k49)
	end
end

---- Bubble Jump

local function BubbleJump(player)
	if player.mo.valid and player.mo.skin == "ace"
		if not player.wiz.jumpability return end
		
		if player.wiz.jumpabilitytime == 35
			player.mo.flags = $|MF_NOGRAVITY|MF_BOUNCE
			
			P_SetObjectMomZ(player.mo, FixedMul(2*FRACUNIT, player.mo.scale), true)
			
			player.wiz.bubble = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEBUBBLE)
			
			if player.wiz.bubble and player.wiz.bubble.valid
				player.wiz.bubble.scale = 1*FRACUNIT/4
				player.wiz.bubble.scalespeed = 1*FRACUNIT/4
				player.wiz.bubble.target = player.mo
				
				S_StartSound(player.mo, sfx_splash)
			end
		end
		
		if (player.mo.subsector.sector.floorpic != "F_SKY1" or player.mo.subsector.sector.ceilingpic != "F_SKY1")
		and player.mo.subsector.sector.special != 6 and player.mo.subsector.sector.special != 7 and abs(player.mo.momz)
			if ((player.mo.z - player.mo.height/4 + player.mo.momz <= player.mo.floorz and not (player.mo.eflags & MFE_VERTICALFLIP))
			or (player.mo.z + player.mo.height + player.mo.height/4 + player.mo.momz >= player.mo.ceilingz and (player.mo.eflags & MFE_VERTICALFLIP)))
				P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + player.mo.height/4 * P_MobjFlip(player.mo))
				
				if abs(player.mo.momz) >= 2*FRACUNIT
					P_SetObjectMomZ(player.mo, player.mo.momz/2 * -P_MobjFlip(player.mo))
					S_StartSound(player.mo, sfx_s3k44)
				else
					P_SetObjectMomZ(player.mo, 0)
				end
			elseif ((player.mo.z + player.mo.height + player.mo.height/2 + player.mo.momz >= player.mo.ceilingz and not (player.mo.eflags & MFE_VERTICALFLIP))
			or (player.mo.z - player.mo.height/2 + player.mo.momz <= player.mo.floorz and (player.mo.eflags & MFE_VERTICALFLIP)))
				P_MoveOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z - player.mo.height/4 * P_MobjFlip(player.mo))
				
				if abs(player.mo.momz) >= 2*FRACUNIT
					P_SetObjectMomZ(player.mo, player.mo.momz/2 * -P_MobjFlip(player.mo))
					S_StartSound(player.mo, sfx_s3k44)
				else
					P_SetObjectMomZ(player.mo, 0)
				end
			end
		end
		
		player.powers[pw_underwater] = underwatertics
		player.powers[pw_spacetime] = spacetimetics
	end
end

addHook("MobjThinker", function(bubble)
	if bubble and bubble.valid
		if bubble.target and bubble.target.valid
			local BubbleZ
			if P_MobjFlip(bubble.target) > 0
				BubbleZ = bubble.target.z - 4*FRACUNIT
				
				bubble.flags2 = $&~MF2_OBJECTFLIP
				bubble.eflags = $&~MFE_VERTICALFLIP
			else
				BubbleZ = bubble.target.z - 2*FRACUNIT - bubble.target.height
				
				bubble.flags2 = $|MF2_OBJECTFLIP
				bubble.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(bubble, bubble.target.x, bubble.target.y, BubbleZ)
			
			bubble.angle = bubble.target.player.drawangle
			
			if bubble.target.player.wiz.jumpability
				bubble.destscale = bubble.target.player.shieldscale
			else
				S_StartSound(bubble.target, sfx_s3k77)
				P_KillMobj(bubble)
			end
		else
			P_RemoveMobj(bubble)
		end
	end
end, MT_ACEBUBBLE)

---- Cloud Surf

local function CloudSurf(player)
	if player.mo.valid and player.mo.skin == "ace"
		if not player.wiz.jumpability S_StopSound(player.mo, sfx_s3kcel) return end
		
		if player.wiz.jumpabilitytime == 35
			player.wiz.cloud = P_SpawnMobjFromMobj(player.mo, 0, 0, -player.mo.height, MT_ACECLOUD)
			
			if player.wiz.cloud and player.wiz.cloud.valid
				player.wiz.cloud.scale = 1*FRACUNIT/4
				player.wiz.cloud.scalespeed = 1*FRACUNIT/4
				player.wiz.cloud.target = player.mo
				
				S_StartSound(player.mo, sfx_wdjump)
			end
		end
		
		if not S_SoundPlaying(player.mo, sfx_s3kcel)
			S_StartSound(player.mo, sfx_s3kcel)
		end
		
		player.acceleration = 20
		player.wiz.jumpabilityloop = true
		
		P_InstaThrust(player.mo, player.drawangle, FixedMul(10*FRACUNIT + (player.speed/2), player.mo.scale))
		P_SetObjectMomZ(player.mo, -3*FRACUNIT)
		
		local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, -player.mo.height/2, MT_THOK)
		
		Thok.color = SKINCOLOR_CLOUDY
		Thok.scalespeed = 1*FRACUNIT/8
		Thok.destscale = 0
	end
end

addHook("MobjThinker", function(cloud)
	if cloud and cloud.valid
		if cloud.target and cloud.target.valid
			local CloudZ
			if P_MobjFlip(cloud.target) > 0
				CloudZ = cloud.target.z - 4*FRACUNIT - cloud.target.height/2
				
				cloud.flags2 = $&~MF2_OBJECTFLIP
				cloud.eflags = $&~MFE_VERTICALFLIP
			else
				CloudZ = cloud.target.z - 2*FRACUNIT + cloud.target.height/2
				
				cloud.flags2 = $|MF2_OBJECTFLIP
				cloud.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(cloud, cloud.target.x, cloud.target.y, CloudZ)
			
			cloud.angle = cloud.target.player.drawangle
			
			if cloud.target.player.wiz.jumpability
				cloud.destscale = cloud.target.player.shieldscale
			else
				if not S_SoundPlaying(cloud.target, sfx_wdjump)
					S_StartSound(cloud.target, sfx_wdjump)
				end
				
				cloud.destscale = 0
				
				if cloud.scale <= 1*FRACUNIT/96
					P_KillMobj(cloud)
				end
			end
		else
			P_RemoveMobj(cloud)
		end
	end
end, MT_ACECLOUD)

---- Flame Dash

local function FlameDash(player)
	if player.mo.valid and player.mo.skin == "ace"
		if not player.wiz.jumpability return end
		
		if player.wiz.jumpabilitytime == 35
			player.acceleration = 20
			player.wiz.fireball = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACEFIREBALL)
			
			if player.wiz.fireball and player.wiz.fireball.valid
				player.wiz.fireball.scale = 1*FRACUNIT/4
				player.wiz.fireball.scalespeed = 1*FRACUNIT/4
				player.wiz.fireball.target = player.mo
				
				S_StartSound(player.mo, sfx_s1b3)
			end
		end
		
		if player.wiz.jumpabilitytime >= 0
			player.charflags = $|SF_CANBUSTWALLS
			
			P_InstaThrust(player.mo, player.drawangle, FixedMul(20*FRACUNIT + (player.speed/2), player.mo.scale))
			P_SetObjectMomZ(player.mo, 0, false)
			
			local ThokZ
			if P_MobjFlip(player.mo) > 0
				ThokZ = 0
			else
				ThokZ = player.mo.height/2
			end
			
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, ThokZ, MT_THOK)
			
			Thok.color = SKINCOLOR_FLAME
			Thok.frame = $|FF_FULLBRIGHT
			Thok.scale = player.mo.scale*3/2
			Thok.scalespeed = 1*FRACUNIT/4
			Thok.destscale = 0
		end
	end
end

addHook("MobjThinker", function(fireball)
	if fireball and fireball.valid
		if fireball.target and fireball.target.valid
			local FireballZ
			if P_MobjFlip(fireball.target) > 0
				FireballZ = fireball.target.z - 4*FRACUNIT
				
				fireball.flags2 = $&~MF2_OBJECTFLIP
				fireball.eflags = $&~MFE_VERTICALFLIP
			else
				FireballZ = fireball.target.z - 2*FRACUNIT - fireball.target.height
				
				fireball.flags2 = $|MF2_OBJECTFLIP
				fireball.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(fireball, fireball.target.x, fireball.target.y, FireballZ)
			
			fireball.angle = fireball.target.player.drawangle
			
			if fireball.target.player.wiz.jumpability
				fireball.destscale = fireball.target.player.shieldscale
			else
				if not S_SoundPlaying(fireball.target, sfx_s1ae)
					S_StartSound(fireball.target, sfx_s1ae)
				end
				
				fireball.destscale = 0
				
				if fireball.scale <= 1*FRACUNIT/96
					P_KillMobj(fireball)
				end
			end
		else
			P_RemoveMobj(fireball)
		end
	end
end, MT_ACEFIREBALL)

-- Activate Jump Ability

---- While Falling

addHook("JumpSpecial", function(player)
	if player.wiz and player.wiz.banstate return end
	
	if player.mo.valid and player.mo.skin == "ace"
	and not (player.pflags & PF_JUMPED) and player.atap
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			if not player.wiz.jumpability and not player.wiz.jumpabilitydelay
				player.wiz.jumpability = true
				
				if (player.pflags & PF_SPINNING)
					player.pflags = $&~PF_SPINNING
				end
			end
		elseif ((gametyperules & GTR_RINGSLINGER) or srb2p) and not (player.pflags & PF_THOKKED)
			P_DoJump(player, true)
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			Thok.color = player.wiz.fairy.color
			player.pflags = $|PF_THOKKED
		end
	end
end)

---- While Jumping

addHook("AbilitySpecial", function(player)
	if player.wiz and player.wiz.banstate return end
	
	if player.mo.valid and player.mo.skin == "ace"
		if not (gametyperules & GTR_RINGSLINGER) and not srb2p
			if not player.wiz.jumpability and not player.wiz.jumpabilitydelay
				player.wiz.jumpability = true
				
				if (player.pflags & PF_SPINNING)
					player.pflags = $&~PF_SPINNING
				end
			end
		elseif ((gametyperules & GTR_RINGSLINGER) or srb2p) and not (player.pflags & PF_THOKKED)
			player.pflags = $&~PF_JUMPED
			P_DoJump(player, true)
			local Thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			Thok.color = player.wiz.fairy.color
			player.pflags = $|PF_THOKKED
		end
	end
end)

-- Vars Check

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.mo and player.mo.skin != "ace" and player.wiz and not player.wiz.allowed
			player.wiz = nil -- You are not worthy to use the wand...
		end
	end
end)

-- Cast Sprites

local CASTSPRITES = {
	[SPR2_STND] = SPR2_CAST,
	[SPR2_WAIT] = SPR2_CAST,
	[SPR2_EDGE] = SPR2_CAST,
	
	[SPR2_WALK] = SPR2_CWLK,
	[SPR2_RUN_] = SPR2_CRUN,
	[SPR2_SKID] = SPR2_CSKD,
	
	[SPR2_JUMP] = SPR2_CAIR,
	[SPR2_SPNG] = SPR2_CAIR,
	[SPR2_FALL] = SPR2_CAIR,
	
	[SPR2_SWIM] = SPR2_CSWM
}

local camera = nil
local firstperson = false
local fpaim = 0

hud.add(function(v, player, realcamera)
	camera = realcamera
	
	if realcamera.chase
		firstperson = false
	else
		firstperson = true
	end
	
	if firstperson
		fpaim = 1
	else
		fpaim = 0
	end
end, "game")

-- Player Think

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "ace" and player.wiz
		local TwoD = twodlevel or (player.mo.flags2 & MF2_TWOD)
		
		if (P_IsObjectOnGround(player.mo) or player.wiz.wallsliding) and (player.pflags & PF_THOKKED)
			player.pflags = $&~PF_THOKKED
		end
		
		-- Jump Ability
		
		if player.wiz.jumpability and not player.wiz.wallsliding
		and not (P_IsObjectOnGround(player.mo) and player.wiz.element != 1)
		and not P_PlayerInPain(player) and player.playerstate == PST_LIVE
		and not (player.mo.eflags & MFE_UNDERWATER) and not player.powers[pw_pushing]
		and not player.wiz.slamming and not player.wiz.diving and not player.wiz.banstate
			if player.wiz.jumpabilitytime == 0 and not player.wiz.jumpabilityloop
				player.wiz.jumpabilitytime = 35
			end
			
			if player.wiz.element == 0
				BoulderJump(player)
			elseif player.wiz.element == 1
				BubbleJump(player)
			elseif player.wiz.element == 2
				CloudSurf(player)
			elseif player.wiz.element == 3
				FlameDash(player)
			end
		end
		
		if player.wiz.jumpabilitytime
			player.wiz.jumpabilitytime = $-1
		end
		
		if (player.wiz.jumpability and ((player.wiz.jumpabilitytime == 0
		and (player.wiz.element == 0 or player.wiz.element == 1 or player.wiz.element == 3
		or player.atap and player.wiz.jumpabilityloop) or ((P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_SPRUNG)) and player.wiz.element != 1)
		or P_IsObjectInGoop(player.mo) or P_InQuicksand(player.mo))
		or P_PlayerInPain(player) or player.playerstate != PST_LIVE
		or (player.mo.eflags & MFE_UNDERWATER)))
		or player.wiz.slamming or player.wiz.diving or player.wiz.banstate
			player.wiz.jumpability = false
			
			if not player.wiz.banstate
				player.wiz.jumpabilitydelay = 50
			elseif player.wiz.banstate and not player.wiz.slidejump and not player.wiz.walljump
				player.wiz.jumpabilitydelay = 15
			else
				player.wiz.jumpabilitydelay = 0
			end
			
			if player.wiz.jumpabilityloop
				player.wiz.jumpabilityloop = false
			end
			
			player.mo.flags = $&~MF_NOGRAVITY&~MF_BOUNCE
			
			player.charflags = $&~SF_CANBUSTWALLS
			
			player.height = 48*FRACUNIT
			
			if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			and not P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_SPRUNG)
			and player.wiz.element != 0 and not player.wiz.banstate
			and not player.wiz.slamming and not player.wiz.diving
				if player.wiz.element != 1
					P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale))
				else
					P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
				end
			end
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.jumpabilitydelay
			player.wiz.jumpabilitydelay = 0
		end
		
		if player.wiz.jumpabilitydelay
			player.wiz.jumpabilitydelay = $-1
		end
		
		-- Crouch and Slide
		
		if player.mo.standingslope and P_IsObjectOnGround(player.mo)
			player.wiz.slidetime = min($+1, 100)
		elseif not P_IsObjectOnGround(player.mo)
			player.wiz.slidetime = 0
		else
			player.wiz.slidetime = max($-1, 0)
		end
		
		if (((player.btap and not player.wiz.crouching) or ((player.cmd.buttons & B) and player.wiz.crouching)
		or ((player.cmd.buttons & X) and player.wiz.diving and player.speed > FixedMul(11*FRACUNIT, player.mo.scale))
		or (TwoD and player.cmd.forwardmove < -20 and not player.mo.currentaxis) or player.wiz.sliding)
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player) and not player.wiz.banstate
		and P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo) and not P_IsObjectInFan(player.mo)
		and player.mo.state != S_PLAY_SKID and not turnoffvar) or player.wiz.forcecrouch or player.wiz.forceslide or player.wiz.sliping
			if not player.wiz.sliping
				player.height = 24*FRACUNIT
			end
			
			local SlideSpeed
			if not player.powers[pw_sneakers]
				if player.gotflag
					SlideSpeed = 25*FRACUNIT
				else
					SlideSpeed = 30*FRACUNIT
				end
			else
				if player.gotflag
					SlideSpeed = 45*FRACUNIT
				else
					SlideSpeed = 50*FRACUNIT
				end
			end
			
			if player.speed <= FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.sliding = false
				player.wiz.crouching = true
				
				player.normalspeed = 5*FRACUNIT
				player.thrustfactor = 3
				player.jumpfactor = 3*FRACUNIT/2
				
				player.acceleration = 40
				player.pflags = $&~PF_SPINNING
				
				if player.xtap and not player.wiz.sliding
					P_InstaThrust(player.mo, player.drawangle, FixedMul(SlideSpeed, player.mo.scale))
					player.pflags = $|PF_SPINNING
					player.wiz.crouching = false
					player.wiz.sliding = true
				end
			elseif player.speed > FixedMul(11*FRACUNIT, player.mo.scale) or player.wiz.sliping
				player.wiz.crouching = false
				player.wiz.forcecrouch = false
				
				if not player.wiz.sliping and not player.wiz.diving
					player.wiz.sliding = true
				end
				
				if player.wiz.diving
					player.pflags = $|PF_JUMPSTASIS
				end
				
				if not (player.pflags & PF_SPINNING)
					P_InstaThrust(player.mo, player.drawangle, FixedMul(SlideSpeed, player.mo.scale))
					player.pflags = $|PF_SPINNING
				end
				
				if not player.wiz.slidetime and (not player.mo.standingslope or (player.mo.standingslope.flags & SL_NOPHYSICS))
					P_Thrust(player.mo, player.drawangle, FixedMul(-player.mo.friction/4 + FixedMul(abs(player.cmd.sidemove), player.acceleration), player.mo.scale))
				elseif player.mo.standingslope and not (player.mo.standingslope.flags & SL_NOPHYSICS)
					P_Thrust(player.mo, player.mo.standingslope.xydirection, player.mo.standingslope.zdelta * P_MobjFlip(player.mo) * 2)
				end
				
				player.acceleration = 500
				player.jumpfactor = 1*FRACUNIT
				
				P_SpawnSkidDust(player, player.mo.radius, true)
			end
		else
			if player.wiz.sliding
				player.pflags = $&~PF_SPINNING
			end
			
			player.wiz.crouching = false
			
			if player.wiz.sliding and not P_IsObjectOnGround(player.mo)
				if (player.pflags & PF_JUMPED)
					player.wiz.slidejump = 25
				end
				
				player.wiz.sliding = false
			end
			
			if not (player.wiz.diving and not P_IsObjectOnGround(player.mo))
				player.height = 48*FRACUNIT
			end
			
			if not player.wiz.jumpability and not player.wiz.wallslide
				player.acceleration = 40
			end
			
			player.normalspeed = 15*FRACUNIT
			player.thrustfactor = 5
			player.jumpfactor = 1*FRACUNIT
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.slidejump
			player.wiz.slidejump = 0
		end
		
		if player.wiz.slidejump
			player.wiz.slidejump = $-1
		end
		
		-- Ceiling Height Check
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and player.mo.ceilingz - player.mo.floorz < FixedMul(48*FRACUNIT, player.mo.scale)
			if player.speed <= FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.forcecrouch = true
			elseif player.speed > FixedMul(11*FRACUNIT, player.mo.scale)
				player.wiz.forceslide = true
			end
		else
			player.wiz.forcecrouch = false
			player.wiz.forceslide = false
		end
		
		-- Sliping
		
		if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_ACECROUCH or player.wiz.sliping)
		and (abs(player.rmomx) > FixedMul(11*FRACUNIT, player.mo.scale) or abs(player.rmomy) > FixedMul(11*FRACUNIT, player.mo.scale))
		and not player.wiz.sliding and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo) and not P_InQuicksand(player.mo)
			player.wiz.sliping = true
			player.pflags = $|PF_JUMPSTASIS
		else
			if player.wiz.sliping
				player.pflags = $&~PF_JUMPSTASIS
				player.pflags = $&~PF_SPINNING
			end
			
			player.wiz.sliping = false
		end
		
		-- Sprint
		
		if ((((player.cmd.buttons & X) or player.machspeedmode)
		and P_IsObjectOnGround(player.mo)) or player.powers[pw_sneakers])
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.banstate and not player.wiz.crouching
		and not player.wiz.sliding and not player.wiz.sliping
		and not player.wiz.slamming and not player.wiz.diving
			player.wiz.sprinting = true
			
			if player.powers[pw_sneakers] and (player.cmd.buttons & X)
				if P_IsObjectOnGround(player.mo)
					if player.gotflag
						player.normalspeed = 45*FRACUNIT
					else
						player.normalspeed = 50*FRACUNIT
					end
					
					player.charflags = $|SF_DASHMODE|SF_RUNONWATER
					
					if player.speed >= FixedMul(player.runspeed, player.mo.scale) -- Totally Radical! (From SRB2 source code)
						if player.dashmode < 3*TICRATE
							player.dashmode = 3*TICRATE
							S_StartSound(player.mo, sfx_rail1)
						end
					else
						player.dashmode = max($-3, 0)
					end
				end
			else
				if player.gotflag
					player.normalspeed = 25*FRACUNIT
				else
					player.normalspeed = 30*FRACUNIT
				end
				
				player.charflags = $&~SF_DASHMODE
				
				if not player.powers[pw_sneakers]
					player.dashmode = 0
				end
				
				if not player.machspeedmode
					player.charflags = $&~SF_RUNONWATER
				end
			end
			
			if player.machspeedmode
				player.charflags = $|SF_RUNONWATER
			end
			
			player.thrustfactor = 10
		else
			player.wiz.sprinting = false
			
			if not player.wiz.wallsliding and not player.wiz.crouching
			and not player.wiz.sliding and not player.wiz.sliping
			and not player.wiz.slamming and not player.wiz.diving
				player.normalspeed = 15*FRACUNIT
				player.thrustfactor = 5
			end
			
			player.dashmode = 0
			player.charflags = $&~SF_DASHMODE
			
			if not player.machspeedmode
				player.charflags = $&~SF_RUNONWATER
			end
		end
		
		if player.mo.state == S_PLAY_DASH and player.dashmode < 3*TICRATE
			player.mo.state = S_PLAY_RUN
		end
		
		-- Fist Slam
		
		if (player.btap and not player.wiz.slamming) and not player.wiz.slamtime
		and not player.wiz.banstate and not player.wiz.jumpability and not player.wiz.wallsliding
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo)
		and not P_IsObjectInFan(player.mo) and not player.gotflag and not player.wiz.diving
			if player.wiz.diving
				player.wiz.diving = false
			end
			
			player.wiz.slamming = true
			player.wiz.slamdelay = 15
			
			player.mo.momx = player.mo.momx/2
			player.mo.momy = player.mo.momy/2
			
			P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
			S_StartSound(player.mo, sfx_ngjump)
		elseif player.wiz.slamming and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			if not player.wiz.slamdelay
				if not P_IsObjectOnGround(player.mo) and not P_IsObjectInGoop(player.mo)
				and not (player.mo.eflags & MFE_SPRUNG) and not P_IsObjectInFan(player.mo)
				and not player.wiz.banstate
					if (player.mo.momz > -30*FRACUNIT and not (player.mo.eflags & MFE_VERTICALFLIP))
					or (player.mo.momz < 30*FRACUNIT and (player.mo.eflags & MFE_VERTICALFLIP))
						P_SetObjectMomZ(player.mo, FixedMul(-30*FRACUNIT, player.mo.scale), true)
						S_StartSound(player.mo, sfx_mswing)
					end
				else
					if P_IsObjectOnGround(player.mo)
						player.wiz.slamtime = 20
						
						if (player.cmd.buttons & B)
							P_SetObjectMomZ(player.mo, FixedMul(10*FRACUNIT, player.mo.scale), true)
						else
							P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
						end
						
						S_StartSound(player.mo, sfx_pstop)
					end
					
					player.wiz.slamming = false
				end
			end
		end
		
		if player.wiz.slamming and (P_IsObjectOnGround(player.mo)
		or P_IsObjectInGoop(player.mo) or P_InQuicksand(player.mo)
		or (player.mo.eflags & MFE_SPRUNG) or P_IsObjectInFan(player.mo)
		or player.wiz.banstate) or player.wiz.wallsliding
			player.wiz.slamming = false
			player.wiz.slamdelay = 0
		end
		
		if player.wiz.slamdelay
			player.wiz.slamdelay = $-1
		end
		
		if P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.wiz.slamtime and player.wiz.slamtime <= 19
			player.wiz.slamtime = 0
		end
		
		if player.wiz.slamtime
			player.wiz.slamtime = $-1
		end
		
		-- Dive
		
		if player.xtap and not player.wiz.diving and not player.wiz.divedelay
		and not P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_SPRUNG)
		and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.banstate and not player.gotflag
		and not player.wiz.jumpability and not player.wiz.wallsliding
		and not player.wiz.crouching and not player.wiz.sliding
		and not player.wiz.sliping and not player.wiz.slamming
			player.wiz.diving = true
			player.height = 24*FRACUNIT
			player.pflags = $|PF_DRILLING
			
			local DiveSpeed
			if not player.powers[pw_sneakers]
				DiveSpeed = 30*FRACUNIT
				S_StartSound(player.mo, sfx_thok)
			else
				DiveSpeed = 50*FRACUNIT
				S_StartSound(player.mo, sfx_rail1)
			end
			
			P_InstaThrust(player.mo, player.drawangle, FixedMul(DiveSpeed, player.mo.scale))
			P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), true)
		elseif (((not (player.cmd.buttons & X) or player.speed <= FixedMul(11*FRACUNIT, player.mo.scale))
		and P_IsObjectOnGround(player.mo)) or (player.atap and not P_IsObjectOnGround(player.mo))
		or P_IsObjectInGoop(player.mo) or ((player.mo.eflags & MFE_SPRUNG) and not player.wiz.slidetime)
		or P_InQuicksand(player.mo)) or player.playerstate != PST_LIVE or P_PlayerInPain(player)
		or player.wiz.banstate or player.wiz.crouching or player.wiz.sliding or player.wiz.sliping
			if player.wiz.diving
				if (P_IsObjectOnGround(player.mo) and not player.wiz.crouching
				and not player.wiz.sliding and not player.wiz.sliping)
				or (not P_IsObjectOnGround(player.mo) and player.atap)
					P_SetObjectMomZ(player.mo, FixedMul(5*FRACUNIT, player.mo.scale), not P_IsObjectOnGround(player.mo))
				end
				
				if not player.wiz.banstate
					player.wiz.divedelay = 30
				end
				
				player.wiz.diving = false
				player.pflags = $&~PF_DRILLING&~PF_JUMPSTASIS&~PF_SPINNING
			end
			
			if not player.wiz.crouching and not player.wiz.sliding
				player.height = 48*FRACUNIT
			end
		end
		
		if P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.wiz.divedelay and player.wiz.divedelay <= 29
			player.wiz.divedelay = 0
		end
		
		if player.wiz.divedelay
			player.wiz.divedelay = $-1
		end
		
		-- Magic --
		
		-- Switch Element
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and not player.wiz.jumpability and not (gametyperules & GTR_RINGSLINGER)
		and not player.wiz.slamming and (not player.wiz.banstate
		or player.wiz.slamtime or player.wiz.slidejump or player.wiz.walljump
		or (player.wiz.divedelay and not player.wiz.diving))
			if player.lbtap
				player.wiz.element = $-1
				S_StartSound(nil, sfx_tink)
			elseif player.rbtap
				player.wiz.element = $+1
				S_StartSound(nil, sfx_tink)
			end
		end
		
		if player.wiz.element < 0
			player.wiz.element = 3
		elseif player.wiz.element > 3
			player.wiz.element = 0
		end
		
		-- Cast
		
		if not player.wiz.wallsliding
			player.wiz.castangle = player.drawangle
		end
		
		if (player.cmd.buttons & RT) and player.playerstate == PST_LIVE
		and not P_PlayerInPain(player) and not player.wiz.banstate
		and player.mo.state != S_PLAY_ROLL and not player.wiz.jumpability
		and not player.wiz.sliding and player.dashmode <= 3*TICRATE
		and not player.wiz.slamming and not player.wiz.diving
		and not player.wiz.castrecharge and not player.wiz.shield
		and not (gametyperules & GTR_RINGSLINGER)
			if player.wiz.casttime > 0
				player.wiz.casting = true
				player.wiz.casttime = $-1
				player.wiz.castdelay = max($-1, 0)
				
				if player.wiz.element == 0 and player.wiz.castdelay == 0
					local Rock = P_SPMAngle(player.mo, MT_ACEEARTH, player.wiz.castangle, fpaim)
					
					if Rock and Rock.valid
						if player.wiz.crouching
							P_MoveOrigin(Rock, Rock.x, Rock.y, Rock.z + Rock.height/4)
						end
						
						Rock.scale = 1*FRACUNIT/4
						Rock.scalespeed = 1*FRACUNIT/4
						Rock.destscale = 1*FRACUNIT
						Rock.tracer = player.mo
					end
					
					player.wiz.castdelay = 5
				elseif player.wiz.element == 1
					local Water = P_SPMAngle(player.mo, MT_ACEWATER, player.wiz.castangle, fpaim)
					
					if Water and Water.valid
						if player.wiz.crouching
							P_MoveOrigin(Water, Water.x, Water.y, Water.z + Water.height/4)
						end
						
						Water.scale = 1*FRACUNIT/2
						Water.scalespeed = 1*FRACUNIT/8
						Water.destscale = 1*FRACUNIT
						Water.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_splish)
					end
				elseif player.wiz.element == 2
					local Wind = P_SPMAngle(player.mo, MT_ACEAIR, player.wiz.castangle, fpaim)
					
					if Wind and Wind.valid
						if player.wiz.crouching
							P_MoveOrigin(Wind, Wind.x, Wind.y, Wind.z + Wind.height/4)
						end
						
						Wind.scale = 1*FRACUNIT/2
						Wind.scalespeed = 1*FRACUNIT/8
						Wind.destscale = 1*FRACUNIT
						Wind.tracer = player.mo
						
						if not S_SoundPlaying(player.mo, sfx_s3kces)
							S_StartSound(player.mo, sfx_s3kces)
						end
					end
				elseif player.wiz.element == 3
					local Flame = P_SPMAngle(player.mo, MT_ACEFIRE, player.wiz.castangle, fpaim)
					
					if Flame and Flame.valid
						if player.wiz.crouching
							P_MoveOrigin(Flame, Flame.x, Flame.y, Flame.z + Flame.height/4)
						end
						
						Flame.scale = 1*FRACUNIT/2
						Flame.scalespeed = 1*FRACUNIT/8
						Flame.destscale = 1*FRACUNIT
						Flame.tracer = player.mo
					end
					
					if player.wiz.castdelay == 0
						player.wiz.castdelay = 5
						S_StartSound(player.mo, sfx_fire)
					end
				end
			else
				player.wiz.castrecharge = true
			end
			
			//CASTSPRITES
			
		else
			player.wiz.casting = false
			player.wiz.castdelay = 0
		end
		
		if player.rttap and player.wiz.castrecharge
			player.wiz.castrecharge = false
		end
		
		if not player.wiz.casting or player.wiz.banstate
			player.wiz.casttime = min($+1, 100)
		end
		
		-- Wall Movement
		
		if player.wiz.wall and player.wiz.wall.valid and player.wiz.wall.special != 41
		and not (player.wiz.wall.flags & ML_NOCLIMB) and (player.cmd.buttons & A) and not player.xtap
		and not P_IsObjectOnGround(player.mo) and player.playerstate == PST_LIVE and not P_PlayerInPain(player)
		and (not player.wiz.banstate or player.wiz.walljump) and not player.wiz.jumpability
			if player.wiz.diving
				player.wiz.diving = false
			end
			
			if player.wiz.walljump
				player.wiz.walljump = 0
			end
			
			if not player.wiz.wallsliding
				player.wiz.wallsliding = true
				S_StartSound(player.mo, sfx_s3k4a)
				
				P_ReturnThrustX(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), player.mo.momx)
				P_ReturnThrustY(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), player.mo.momy)
			end
			
			if P_GetPlayerControlDirection(player) == 1 and player.speed >= 3*FRACUNIT
				player.drawangle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
				player.wiz.castangle = player.wiz.wallnormal + ANGLE_180
			else
				player.drawangle = player.wiz.wallnormal + ANGLE_180
				player.wiz.castangle = player.wiz.wallnormal + ANGLE_180
				
				P_SpawnSkidDust(player, player.mo.radius, true)
			end
			
			if not player.powers[pw_pushing]
				if player.wiz.wallslidetime
					P_Thrust(player.mo, player.wiz.wallnormal, FixedMul(4*FRACUNIT, player.mo.scale))
					
					player.wiz.wallslidetime = $-1
				else
					player.wiz.wallsliding = false
					player.wiz.wall = nil
					
					player.wiz.wallslidetime = 2
				end
			else
				player.wiz.wallslidetime = 2
			end
			
			P_ReturnThrustX(player.mo, player.wiz.wallnormal, player.mo.momx)
			P_ReturnThrustY(player.mo, player.wiz.wallnormal, player.mo.momy)
			
			player.acceleration = 500
			
			if player.powers[pw_sneakers]
				if player.gotflag
					player.normalspeed = 45*FRACUNIT
				else
					player.normalspeed = 50*FRACUNIT
				end
			else
				if player.gotflag
					player.normalspeed = 25*FRACUNIT
				else
					player.normalspeed = 30*FRACUNIT
				end
			end
			
			if player.mo.momz >= player.mo.subsector.sector.gravity*16
				P_SetObjectMomZ(player.mo, FixedMul(mo.subsector.sector.gravity*16, player.mo.scale))
			elseif player.mo.momz <= -player.mo.subsector.sector.gravity*16
				P_SetObjectMomZ(player.mo, FixedMul(-player.mo.subsector.sector.gravity*16, player.mo.scale))
			end
		elseif (not (player.cmd.buttons & A) or player.xtap) and player.wiz.wallsliding
			player.wiz.wallsliding = false
			player.wiz.wall = nil
			
			if player.xtap
				player.wiz.walljump = 25
				
				player.mo.angle = player.wiz.wallnormal + ANGLE_180
				
				P_Thrust(player.mo, player.wiz.wallnormal, FixedMul(-20*FRACUNIT, player.mo.scale))
				P_SetObjectMomZ(player.mo, FixedMul(10*FRACUNIT, player.mo.scale))
				S_StartSound(player.mo, sfx_jump)
			end
		else
			player.wiz.wallsliding = false
			player.wiz.wall = nil
		end
		
		if P_IsObjectOnGround(player.mo)
			player.wiz.wallslidedelay = 10
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.walljump
			player.wiz.walljump = 0
		end
		
		if player.wiz.walljump
			player.wiz.walljump = $-1
		end
		
		if P_IsObjectOnGround(player.mo) and player.wiz.wallbonk
			player.wiz.wallbonk = 0
		end
		
		if player.wiz.wallbonk
			player.wiz.wallbonk = $-1
		end
		
		-- State Machine
		
		if player.playerstate == PST_LIVE and not P_PlayerInPain(player)
			if player.wiz.jumpability and player.wiz.element == 0
				player.mo.state = S_PLAY_ACEBOULDERJUMP
			elseif player.wiz.jumpability and player.wiz.element == 1
				player.mo.state = S_PLAY_ACEBUBBLEJUMP
			elseif player.wiz.jumpability and player.wiz.element == 2
				player.mo.state = S_PLAY_ACECLOUDSURF
			elseif player.wiz.jumpability and player.wiz.element == 3
				player.mo.state = S_PLAY_ACEFLAMEDASH
			elseif player.wiz.wallsliding or player.wiz.walljump >= 24
				if not P_IsObjectOnGround(player.mo)
					if P_GetPlayerControlDirection(player) == 1 and player.speed >= 3*FRACUNIT
						player.mo.state = S_PLAY_WALK
					else
						player.mo.state = S_PLAY_CLING
					end
					
					if player.wiz.walljump and not player.wiz.wallsliding
						player.mo.state = S_PLAY_SPRING
					end
				else
					player.mo.state = S_PLAY_STND
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			elseif player.wiz.wallbonk
				if player.wiz.wallbonk <= 1 or P_IsObjectOnGround(player.mo)
					if player.mo.state == S_PLAY_STUN
						player.mo.tics = 8
					end
				else
					if player.mo.state != S_PLAY_STUN
						player.mo.state = S_PLAY_STUN
					end
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			elseif player.wiz.crouching
				if abs(player.speed) >= FRACUNIT or P_GetPlayerControlDirection(player) == 1
					player.mo.state = S_PLAY_ACECRAWL
				else
					player.mo.state = S_PLAY_ACECROUCH
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			elseif player.dashmode > 3*TICRATE
				if not srb2p
					player.powers[pw_strong] = STR_METAL
				end
			elseif (player.wiz.slamming or player.wiz.slamtime) and not player.wiz.diving
				if not player.wiz.slamtime
					if player.wiz.slamdelay
					and player.mo.state != S_PLAY_ACESLAM_WIND
					and player.mo.state != S_PLAY_ACESLAM_WIND_2
						player.mo.state = S_PLAY_ACESLAM_WIND
					elseif not player.wiz.slamdelay
					and player.mo.state != S_PLAY_ACESLAM
					and player.mo.state != S_PLAY_ACESLAM_2
						player.mo.state = S_PLAY_ACESLAM
						
						if not srb2p
							player.powers[pw_strong] = STR_ANIM|STR_FLOOR|STR_SPRING|STR_HEAVY|STR_STOMP
						end
					end
				elseif player.wiz.slamtime >= 19
					if (player.cmd.buttons & B)
						player.mo.state = S_PLAY_ACESLAM_BOUNCE
					else
						player.mo.state = S_PLAY_ACESLAM_LAND
					end
					
					if not srb2p
						player.powers[pw_strong] = STR_NONE
					end
				end
			elseif (player.wiz.diving or player.wiz.divedelay) and not player.wiz.slamming
				if not player.wiz.divedelay
					player.mo.state = S_PLAY_ACEDIVE
					
					if not srb2p
						player.powers[pw_strong] = STR_ANIM|STR_PUNCH
					end
				elseif player.wiz.divedelay >= 29
					player.mo.state = S_PLAY_ACEDIVE_UNDIVE
					
					if not srb2p
						player.powers[pw_strong] = STR_NONE
					end
				end
			elseif player.wiz.sliding or player.wiz.slidejump >= 24
				if not player.wiz.slidejump
					player.mo.state = S_PLAY_ACESLIDE
					
					if not srb2p
						player.powers[pw_strong] = STR_ANIM|STR_PUNCH
					end
				else
					player.mo.state = S_PLAY_ACESLIDE_JUMP
					
					if not srb2p
						player.powers[pw_strong] = STR_NONE
					end
				end
			elseif player.wiz.sliping
				player.mo.state = S_PLAY_ACESLIP
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			else
				if not player.powers[pw_justlaunched] and not P_IsObjectOnGround(player.mo)
					if (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN
					or player.mo.state == S_PLAY_DASH or player.mo.state == S_PLAY_CLING)
					and not player.powers[pw_carry]
						player.mo.state = S_PLAY_FALL
					end
				elseif player.powers[pw_justlaunched] and not P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_SPRING
				end
				
				if not srb2p
					player.powers[pw_strong] = STR_NONE
				end
			end
		end
		
		if (player.mo.state == S_PLAY_EDGE
		or player.mo.state == S_PLAY_ACESLIDE_JUMP
		or player.mo.state == S_PLAY_ACESLIP
		or player.mo.state == S_PLAY_ACESLAM_BOUNCE
		or player.mo.state == S_PLAY_ACESLAM_LAND
		or player.mo.state == S_PLAY_ACEDIVE_UNDIVE
		or (player.mo.state == S_PLAY_ROLL
		and P_IsObjectOnGround(player.mo))) or pso
		or player.powers[pw_carry] == CR_ZOOMTUBE
		or player.powers[pw_carry] == CR_NIGHTSMODE
		or player.exiting or player.wiz.slidejump
		or (player.wiz.slamtime and not player.wiz.slamming)
		or (player.wiz.divedelay and not player.wiz.diving)
		or player.wiz.wallbonk or player.wiz.walljump
		or player.wiz.ondragon or player.mo.frostburnt
		or player.frozen or player.dirk_frozen
		or (player.eggride and player.eggride.state)
			player.wiz.banstate = true
		else
			player.wiz.banstate = false
		end
	else
		player.wiz =
		{element = 0,
		casting = false,
		castaim = 0,
		casttime = 100,
		castangle = 0,
		castrecharge = false,
		castdelay = 0,
		shield = false,
		shieldtime = 100,
		shieldrecharge = false,
		shielddelay = 0,
		parry = false,
		parrytime = 2,
		jumpability = false,
		jumpabilityloop = false,
		jumpabilitytime = 0,
		jumpabilitydelay = 0,
		crouching = false,
		forcecrouch = false,
		sliding = false,
		slidejump = 0,
		slidetime = 0,
		forceslide = false,
		sliping = false,
		slamming = false,
		slamdelay = 0,
		slamtime = 0,
		sprinting = false,
		diving = false,
		divedelay = 0,
		wall = nil,
		wallsliding = false,
		wallslidetime = 0,
		walljump = 0,
		wallbonk = 0}
	end
end)

-- Wall Collision

addHook("MobjMoveBlocked", function(mo, mobj, wall)
	if mo and mo.valid and mo.player and mo.skin == "ace"
		if mo.player.powers[pw_carry] or (mo.player.wiz and mo.player.wiz.ondragon) return end
		
		P_SlideMove(mo)
		
		mo.player.powers[pw_pushing] = 3
		
		if wall and wall.valid
			if (wall.frontsector)
				if (wall.frontsector.ceilingheight == wall.frontsector.floorheight
				and mo.z + mo.height > wall.frontsector.ceilingheight)
					return
				end
			end
			
			if (wall.backsector)
				if (wall.backsector.ceilingheight == wall.backsector.floorheight
				and mo.z + mo.height > wall.backsector.ceilingheight)
					return
				end
			end
			
			local directangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
			local anglediff = mo.player.drawangle - directangle
			
			mo.player.wiz.wall = wall
			mo.player.wiz.wallnormal = R_PointToAngle2(mo.x, mo.y, P_ClosestPointOnLine(mo.x, mo.y, mo.player.wiz.wall))
			
			-- Wall Bonk
			
			if ((mo.player.wiz.jumpability and (mo.player.wiz.element == 2 or mo.player.wiz.element == 3))
			or (mo.player.wiz.diving and not (mo.player.cmd.buttons & X))
			or (mo.player.wiz.sprinting and mo.player.dashmode > 3*TICRATE))
				if abs(anglediff) > ANGLE_45
					if abs(mo.player.speed) >= 24*FRACUNIT
						mo.player.wiz.wallbonk = 25
						mo.player.wiz.divedelay = mo.player.wiz.wallbonk + 10
						
						mo.player.drawangle = mo.player.wiz.wallnormal
						
						mo.angle = mo.player.drawangle
						
						P_Thrust(mo, mo.player.wiz.wallnormal, FixedMul(-5*FRACUNIT, mo.scale))
						P_SetObjectMomZ(mo, FixedMul(8*FRACUNIT, mo.scale))
						
						S_StartSound(mo, sfx_s3k49)
					else
						mo.player.wiz.banstate = true
					end
				else
					P_ReturnThrustX(mo, directangle, mo.momx)
					P_ReturnThrustY(mo, directangle, mo.momy)
					
					mo.player.drawangle = directangle
				end
			elseif mo.player.wiz.jumpability and mo.player.wiz.element == 1
				P_BounceMove(mo)
				S_StartSound(mo, sfx_s3k44)
				
				mo.player.drawangle = directangle
			end
		//elseif mobj and mobj.valid
			
		end
	else
		return
	end
	
	return true
end, MT_PLAYER)

-- Spring Check

local function SpringCheck(mo, spring)
	if not (spring and spring.valid)
	or not (mo and mo.valid)
		return
	end
	
	if (spring.flags & MF_SPRING)
	and mo.z <= spring.z + spring.height
	and mo.z + mo.height >= spring.z
		if P_IsObjectOnGround(mo) and mobjinfo[spring.type].damage
			mo.player.wiz.slidetime = mobjinfo[spring.type].damage
		end
	end
end

addHook("MobjCollide", SpringCheck, MT_PLAYER)
addHook("MobjMoveCollide", SpringCheck, MT_PLAYER)

-- Player Attacks

addHook("PlayerCanDamage", function(player)
	if player.mo.valid and player.mo.skin == "ace"
		if (player.wiz.jumpability and player.wiz.element == 3)
		or player.wiz.sliding or (player.wiz.slamming or player.wiz.slamtime)
		or player.wiz.diving
			return true
		end
		
		if player.wiz.sliping
			return false
		end
	end
end)

-- Player Protection

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.skin == "ace"
	and not (damagetype & DMG_DEATHMASK)
		if target.player.wiz.shield and not (damagetype and damagetype == DMG_NUKE)
		and target.player.wiz.shieldorb and target.player.wiz.shieldorb.valid
			return false
		end
		
		if target.player.wiz.jumpability and target.player.wiz.element == 1
		and damagetype and damagetype == DMG_WATER
			return false
		end
		
		if target.player.wiz.jumpability and target.player.wiz.element == 3
		and damagetype and damagetype == DMG_FIRE
			return false
		end
	end
end, MT_PLAYER)

-- Player Damage (WIP)

/*addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.skin == "ace"
		if target.player.wiz.shield
		and target.player.wiz.shieldorb and target.player.wiz.shieldorb.valid
		and damagetype == DMG_NUKE//not target.player.wiz.parry and damagetype == DMG_NUKE
			P_PlayerInPain(target.player)
			//P_PlayDeathSound(target)
		end
	end
end, MT_PLAYER)*/

-- Casted Elements

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid and mobj.tracer
	and mobj.tracer.player and mobj.tracer.player.valid
		if mobj.type == MT_ACEEARTH or mobj.type == MT_ACEBOULDER
			//if 
				
			//end
		elseif mobj.type == MT_ACEWATER
			//if 
				
			//end
		elseif mobj.type == MT_ACEAIR
			//if 
				
			//end
		elseif mobj.type == MT_ACEFIRE
			//if 
				
			//end
		end
		
		mobj.info.speed = 30*FRACUNIT + mobj.tracer.player.speed
	end
end)

local function ElementsCollide(mobj, target) -- Sounds like that movie...
	if not target or not target.valid or not mobj or not mobj.valid
	or not (mobj.z <= target.z + target.height and target.z <= mobj.z + mobj.height)
	or (mobj.type != MT_ACEEARTH and mobj.type != MT_ACEBOULDER and mobj.type != MT_ACEWATER
	and mobj.type != MT_ACEAIR and mobj.type != MT_ACEFIRE) return end
	if not mobj.tracer or not mobj.tracer.valid or mobj.tracer == target return false end
	
	if target and target.valid
		if (target.type == MT_SPIKE or target.type == MT_WALLSPIKE
		or target.type == MT_SALOONDOOR or target.type == MT_SALOONDOORCENTER) -- Here's another character that can do the ACZ2 Minecart skip.
		and (mobj.type == MT_ACEEARTH or mobj.type == MT_ACEBOULDER)
			if target.type == MT_SALOONDOOR
				P_SpawnMobjFromMobj(target, 0, 0, target.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height - mobj.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height/2 + mobj.height, MT_WOODDEBRIS)
				P_SpawnMobjFromMobj(target, 0, 0, target.height/2 - mobj.height, MT_WOODDEBRIS)
				
				S_StartSound(mo, sfx_wbreak)
			end
			
			P_KillMobj(target, mobj)
		end
	end
	
	if target and target.valid
		if (target.flags & MF_FIRE) and (mobj.type == MT_ACEWATER or mobj.type == MT_ACEAIR)
			if target.target
				if target.target.burning
					target.target.burning = false
				end
			end
			
			local Smoke = P_SpawnMobj(target.x, target.y, target.z + target.height/4, MT_SMOKE)
			Smoke.scale = target.radius/8
			
			S_StartSound(target, sfx_steam1)
			P_KillMobj(target, mobj)
		end
	end
	
	if target and target.valid
		if mobj.type == MT_ACEAIR and ((target.flags & MF_PUSHABLE)
		or (target.flags & MF_ENEMY) or (target.flags & MF_BOSS))
			P_InstaThrust(target, mobj.angle, (mobjinfo[mobj.type].speed/2)-mobjinfo[target.type].speed)
		end
	end
	
	if target and target.valid
		if not target.player and not target.burning
		and not (target.flags & MF_FIRE) and ((target.flags & MF_SCENERY)
		or (target.flags & MF_ENEMY) or target.type == MT_FLAMEHOLDER
		or target.type == MT_TORCHFLOWER) and mobj.type == MT_ACEFIRE
			local Height
			if target.type == MT_FLAMEHOLDER or target.type == MT_TORCHFLOWER
				Height = target.height
			else
				Height = target.height/4
			end
			
			local Flame = P_SpawnMobj(target.x, target.y, target.z + Height, MT_FLAME)
			
			Flame.flags = MF_NOGRAVITY|MF_FIRE
			Flame.target = target
			
			if target.type != MT_FLAMEHOLDER and target.type != MT_TORCHFLOWER
				Flame.fuse = TICRATE*2
			end
			
			S_StartSound(target, sfx_s1b3)
			
			target.burning = true
		end
		
		if (target.flags & MF_FIRE) and mobj.type == MT_ACEFIRE
			mobj.flags = $&~MF_MISSILE
		end
	end
end

addHook("MobjCollide", ElementsCollide)
addHook("MobjMoveCollide", ElementsCollide)

addHook("MobjThinker", function(flame)
	if not flame or not flame.valid return end
	if not flame.target or not flame.target.valid return end
	
	local Height
	if flame.target.type == MT_FLAMEHOLDER or flame.target.type == MT_TORCHFLOWER
		Height = flame.target.height
		
		flame.scale = flame.target.scale
		flame.target.burning = true
	else
		Height = flame.target.height/4
		flame.scale = flame.target.radius/8
		
		P_DamageMobj(flame.target, flame, flame, DMG_FIRE)
	end
	
	P_MoveOrigin(flame,
	flame.target.x + flame.target.momx,
	flame.target.y + flame.target.momy,
	flame.target.z + Height + flame.target.momz)
	
	if not flame.target.health
		P_KillMobj(flame)
	end
end, MT_FLAME)

addHook("MobjFuse", function(flame)
	flame.target.burning = false
end, MT_FLAME)